
/*----------------------------------------------------------------------------------------------------*\
	Projet :		qkDocs
	Version :		1.8 (11-2011)
	Role : 		Petit moteur de publication de documentations en ligne
	Auteur :		FredoMkb (c) 2010 (http://fredomkb.free.fr/)
	License :		Projet libre et open-source
\*----------------------------------------------------------------------------------------------------*/

/*--------------------------------------------------*/

// Fonction pour insérer une balise image dans le texte
// http://www.siteduzero.com/tutoriel-3-34703-insertion-de-balises-dans-une-zone-de-texte.html
function f_mktag(sSrc, sDbt, sFin, sId, bRel, bBox) {
var sVal = '';
var bDbt = 0 + (sDbt !== '');
var bFin = 0 + (sFin !== '');
var sRetAv = '';
var sRetAp = '';
var nRetAv = 0;
var nRetAp = 0;
if (bRel) { sVal = sSrc.rel; }
if (bBox) { 
	if (bDbt) { sRetAv = "\n"; nRetAv = 2; }
	if (bFin) { sRetAp = "\n"; nRetAp = 2; }
}
var field = document.getElementById(sId); 
var scroll = field.scrollTop;
field.focus();
if (window.ActiveXObject) { // Pour IE
	var textRange = document.selection.createRange();	  
	var currentSelection = textRange.text;
	var sCnt = currentSelection;
	if (bRel) { sCnt = sVal; }
	textRange.text = sRetAv + sDbt + sRetAv + sCnt + sRetAp + sFin + sRetAp;
	textRange.moveStart("character", -sFin.length - currentSelection.length + nRetAv);
	textRange.moveEnd("character", -sFin.length + nRetAp);
	textRange.select();   
} else { // Non IE
	var startSelection = field.value.substring(0, field.selectionStart);
	var currentSelection = field.value.substring(field.selectionStart, field.selectionEnd);
	var endSelection = field.value.substring(field.selectionEnd);
	var sCnt = currentSelection;
	if (bRel) { sCnt = sVal; }
	field.value = startSelection + sRetAv + sDbt + sRetAv + sCnt + sRetAp + sFin + sRetAp + endSelection;
	field.focus();
	field.setSelectionRange(startSelection.length + sDbt.length + nRetAv, startSelection.length + sDbt.length + currentSelection.length + nRetAp);
} 
field.scrollTop = scroll; // et on redéfinit le scroll.
}

/*--------------------------------------------------*/

// Fonction pour afficher un texte d'info pour les boutons tags
function f_infos(sSrc, sDst) {
if (window.ActiveXObject) { // Pour IE
	document.getElementById(sDst).innerText = sSrc.title;
} else { // Non IE
	document.getElementById(sDst).firstChild.nodeValue = sSrc.title;
} 
}

/*--------------------------------------------------*/

// Fonction pour retablir la version precedente d'une page
function f_archive(sSrc, sDst) {
	document.getElementById(sDst).value = document.getElementById(sSrc).value;
}

/*--------------------------------------------------*/

// Fonction pour rétablir les valeurs originales de configuration
function f_cnfdft() {
document.getElementById("qdsite").value = "qkDocs";
document.getElementById("qdlogo").value = "_qd/qd064.png";
document.getElementById("qddfnm").value = "Accueil";
document.getElementById("qdadmn").value = "admin";
document.getElementById("qdrdac").value = "redac";
document.getElementById("qdupmx").value = "2";
document.getElementById("qdhaut").value = "380";
document.getElementById("qdcoul").checked = "checked";
document.getElementById("qdsmyl").checked = "checked";
document.getElementById("qdtrgt").checked = "checked";
document.getElementById("qdmsqn").checked = "checked";
}

/*--------------------------------------------------*/

// Fonction prévisualiser une image
function f_prevu(sSrc, sDst) {
document.getElementById(sDst).src = sSrc.href;
}

/*--------------------------------------------------*/

// Fonction pour afficher un objet
function f_show(sId, sStyle) {
if (!sStyle) { sStyle = 'block'; }
document.getElementById(sId).style.display = sStyle;
}

/*--------------------------------------------------*/

// Fonction pour masquer un objet
function f_hide(sId) {
document.getElementById(sId).style.display = 'none';
}

/*--------------------------------------------------*/

// Fonction pour afficher/masquer un objet
function f_showhide(sId, sStyle) {
if (document.getElementById(sId).style.display == 'none') {
	f_show(sId, sStyle);
} else {
	f_hide(sId);
}
}

/*--------------------------------------------------*/


