<?php
/*------------------------------------------------------------------------------------------------------------------------------------------------------*\
	Projet :		qkDocs
	Version :		1.8 (11-2011)
	Role : 		Petit moteur de publication de documentations en ligne
	Auteur :		FredoMkb (c) 2010 (http://fredomkb.free.fr/)
	License :		Projet libre et open-source
\*------------------------------------------------------------------------------------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------------------------------*\
	Hacer :
	-- 1.4
	- [Installation des éléments de base]
	- [Système de cache]
	- [Système de sauvegarde de la version précédente]
	- [Ajouter tag liens de type ancres]
	- [Ajouter des raccourcis clavier pour les boutons]
	- [Nom de la page d'accueil configurable]
	-- 1.6
	- [Système de gestion de redacteurs]
	- [Système de gestion de brouillons]
	- [Ajouter config taille max des documents Pdf et Zip]
	- [Système de noms de fichiers par fichier intermédiaire]
	- [Ouverture des liens externes dans des nouvelles fenêtres]
	- [Cryptage des adresses e-mail]
	- [Essayer d'organiser le code source suivant l'architecture MVC]
	-- 1.7
	- [Formatage des notes de bas de page : ((n)(texte)) = "\(\((\d+)\)\((.*?)\)\)"]
	- [Système de recherche]
	- [Ajouter tags smileys]
	-- 1.8
	- [Changer l'icône du programme et autoriser une dimension max à 64 pixels dans l'en-tête]
	- [Page d'aide pour les formatages dans la section "Brouillons" (demande pertinante de Borak sur MacFr)]
	- [Supprimer l'aide pour la saisie de listes et des tableaux présente sous le formulaire de rédaction]
	- [Augmenter la dimension horizontale du site, pour passer de 900 à 1080 pixels]
	- [Augmenter la marge interne du bloc des contenus]
	- [Augmenter légèrement la taille des titres des blocs]
	- [Alligner le logo et le titre du site à gauche]
	- [Intervertir gauche/droite le bloc menu et le bloc de contenus]
	- [Configurer l'affichage ou non des boutons de coloriage des textes]
	- [Remplacer le signe dollar "$" dans les textes par l'entitée Html correspondante "&#036;"]
	- [Sortir la signature et le compteur du pied de page pour ne laisser que les boutons]
	- [Insérer le compteur de vues-visites uniquement si la fonction "f_sc" existe (fichier "_sc.php")]
	- [Modifier le tag pour le smyler ":-l" en remplaçant la lettre "l" par la barre verticale "|"]
	- [Modifier le texte du bouton de recherche par le signe "√" (entitée Html "&radic;")]
	--
	- Résoudre le cas des listes ordonnées et désordonnées imbriquées
	- Système de sections
	- Système de commentaires
	- Découpage du code en fichiers séparés
	- Externaliser tous les codes templates (avec qkModels)
	- Formatage pour insertion des textes invisibles
	- Formatage pour insertion des vidéos
	- Système de templates personnalisés
	- Séparer les textes de l'interface
	- Système de gestion de langues
	- Compteur télchargements
	- Système de styles personnalisés
	- Système de sélection de thèmes
	- Sommaire automatique pour les articles
	- Système de mots clés
	- Système de glossaire
	- Formatage des blocs de citation thématiques : ;;;(#) = ";;;\([?i:!-x]\)\s(.*?)\s;;;\s" : "aide" = (?), "info" = (i) , "note" = (:), "important" = (!), "attention" = (-), "danger" = (x).
	- Modèle Html (template) du fichier "index.php"
	----
	Corrections :
	- [Corriger système de recherche (variable globale à la palce de $_GET)]
	- [Améliorer la gestion des corrections typo "f_clean_typo_html()"]
	----
	Bugs :
	- [Impossible d'insérer deux liens dans le même paragraphe]
\*----------------------------------------------------------------------------------------------------*/


/*------------------------------------------------------------------------------------------------------------------------------------------------------*\
	Initialisation - Installation
\*------------------------------------------------------------------------------------------------------------------------------------------------------*/

/*--------------------------------------------------*/
// Pour le debogage
$aDbg = array();
$bDbg = 0;
// global $bDbg, $aDbg;
// if ($bDbg) { $aDbg['key'] = $val; }

/*--------------------------------------------------*/
// Constantes d'infos projet

define('QDNAME', 'qkDocs');
define('QDVERS', '1.8');
define('QDCOPY', 'FredoMkb &copy; '.date('Y'));
define('QDLINK', 'http://fredomkb.free.fr/');

/*--------------------------------------------------*/
// Langue du site

$aLangCharset = array('fr_FR.UTF-8', 'fr_FR', 'fr', 'fr_FR.ISO8859-15', 'fr_FR.ISO8859-1' );
setlocale(LC_ALL, $aLangCharset);

/*--------------------------------------------------*/
// Constantes principales de travail

// Chemins
define('QDHOME', 'index.php'); // Fichier d'intégration
define('QDROOT', dirname($_SERVER['PHP_SELF']).'/'); // Dossier principal
define('QDSELF', basename($_SERVER['PHP_SELF'])); // Fichier d'exécution // __FILE__
define('QDDIR', '_qd/'); // Dossier de qkDocs

define('QDCNF', QDDIR.'_qd_cnf.php'); // Fichier de configuration
define('QDPON', QDDIR.'_qd_pon.php'); // Fichier listant le nom des pages publiées
define('QDPOF', QDDIR.'_qd_pof.php'); // Fichier listant le nom des pages non publiées
define('QDSTY', QDDIR.'_qd_sty.php'); // Fichier listant les sytles personnalisés

define('QDPAGES', 'pages/'); // Dossier des pages
define('QDMEDIAS', 'medias/'); // Dossier des fichiers médias (images et documents)
define('QDCACH', 'caches/'); // Dossier des caches
define('QDARCH', 'archives/'); // Dossier des archives (version précédente) 

// Config Défauts
define('QDPGE', 'pge'); // Nom de la variable utilisée dans l'Url pour l'affichage des pages
define('QDJOB', 'job'); // Nom de la variable utilisée dans l'Url pour les actions à effectuer
define('QDPUB', 'pub'); // Nom de la variable utilisée dans l'Url pour les états de publication
define('QDRCH', 'rch'); // Nom de la variable utilisée dans l'Url pour les recherches
define('QDLNG', 28); // Longueur maximum des noms des fichiers
define('QDMAX', 1); // Poids maximum pour les fichiers à uploader : 100000 = 100ko ; 500000 = 500ko ; 1000000 = 1Mo intval(QDMAX * 1000000);.

/*--------------------------------------------------*/
// Constantes annexes de travail 

// Formats
// http://fr.selfhtml.org/divers/typesmime.htm
// http://www.sfsu.edu/training/mimetype.htm
// text/plain = .txt
define('QDTXT', '.txt');
define('QDTXTMT', 'text/plain');
// text/html = .html
define('QDHTM', '.html');
define('QDHTMMT', 'text/html');
// image/jpeg = .jpg
define('QDJPG', '.jpg');
define('QDJPGMT', 'image/jpeg');
// image/png = .png
define('QDPNG', '.png');
define('QDPNGMT', 'image/png');
// image/gif = .gif
define('QDGIF', '.gif');
define('QDGIFMT', 'image/gif');
// application/pdf = .pdf
define('QDPDF', '.pdf');
define('QDPDFMT', 'application/pdf');
// application/zip = .zip
define('QDZIP', '.zip');
define('QDZIPMT', 'application/zip');
// application/x-httpd-php = .php
define('QDPHP', '.php');
define('QDPHPMT', 'application/x-httpd-php');

// Caractères
define('ST', chr(2)); // Start of Text
define('ET', chr(3)); // End of Text
define('BS', chr(8)); // Backspace
define('HT', chr(9)); // Horizontal Tab : tabulation
define('LF', chr(10)); // Line Feed : new line = retour à la ligne
define('CR', chr(13)); // Carriage Return : new paragraph = retour chariot
define('SP', chr(32)); // Space : espace

// Regex
define('QDMRK', '~_~_~'); //  '@_@_@', '%_%_%' , '&_&_&'
define('QDSVE', '%_%_%'); 

/*--------------------------------------------------*/
// Constantes de configuration utilisateur // qdcoul QDCOUL

if (is_file(QDCNF)) {
	// Config utilisateur enregistrée
	include(QDCNF); 
} else {
	// Config utilisateur par défaut
	define('QDSITE', QDNAME);  // Le nom du site qui sera affiché sur le bandeau de tête
	define('QDLOGO', QDDIR.'qd064.png');  // Le logo du site qui sera affiché sur le bandeau de tête
	define('QDADMN', 'admin'); // Le mot de passe adminstrateur pour créer, modifier ou supprimer les contenus
	define('QDRDAC', 'redac'); // Le mot de passe des redacteurs pour créer et modifier les contenus
	define('QDDFPG', 'Accueil'); // Page d'accueil par défaut, toujours existante
	define('QDDFNM', 'Accueil'); // Nom de la page d'accueil par défaut
	define('QDUPMX', 2); // Poids maximum pour les fichiers à uploader : 2 Mo = 2000000.
	define('QDHAUT', 380); // La heuteur du champ texte de saisie en pixels
	define('QDCOUL', 1); // Afficher les boutons des couleurs : 1 = oui ; 0 (zéro) = non.
	define('QDSMYL', 1); // Insérer les smileys : 1 = oui ; 0 (zéro) = non.
	define('QDTRGT', 1); // Ouvrir les liens externes dans une nouvelle fenêtre : 1 = oui ; 0 (zéro) = non.
	define('QDMSQN', 1); // Masquer les numéros des pages : 1 = oui ; 0 (zéro) = non. 
}

/*----------------------------------------------------------------------------------------------------*/
// Variables et masques RegEx pour les formatages des contenus

$aSmileys = array(
	'`'.preg_quote(':-|').'`e' => 'f_save_html(\'<img src="'.QDDIR.'01.gif" alt=":-|" class="smy" />\');',
	'`'.preg_quote(':-)').'`e' => 'f_save_html(\'<img src="'.QDDIR.'02.gif" alt=":-)" class="smy" />\');',
	'`'.preg_quote(':-}').'`e' => 'f_save_html(\'<img src="'.QDDIR.'03.gif" alt=":-}" class="smy" />\');',
	'`'.preg_quote(':-]').'`e' => 'f_save_html(\'<img src="'.QDDIR.'04.gif" alt=":-]" class="smy" />\');',
	'`'.preg_quote(':-p').'`e' => 'f_save_html(\'<img src="'.QDDIR.'05.gif" alt=":-p" class="smy" />\');',
	'`'.preg_quote(';-)').'`e' => 'f_save_html(\'<img src="'.QDDIR.'06.gif" alt=";-)" class="smy" />\');',
	'`'.preg_quote(':-o').'`e' => 'f_save_html(\'<img src="'.QDDIR.'07.gif" alt=":-o" class="smy" />\');',
	'`'.preg_quote('8-/').'`e' => 'f_save_html(\'<img src="'.QDDIR.'08.gif" alt="8-/" class="smy" />\');',
	'`'.preg_quote(':-/').'`e' => 'f_save_html(\'<img src="'.QDDIR.'09.gif" alt=":-/" class="smy" />\');',
	'`'.preg_quote(':-(').'`e' => 'f_save_html(\'<img src="'.QDDIR.'10.gif" alt=":-(" class="smy" />\');',
	'`'.preg_quote(')-(').'`e' => 'f_save_html(\'<img src="'.QDDIR.'11.gif" alt=")-(" class="smy" />\');',
	'`'.preg_quote('+o+').'`e' => 'f_save_html(\'<img src="'.QDDIR.'12.gif" alt="+o+" class="pom" />\');',
);

$aMaskTags = array(
	// On preserve les textes a proteger
	'`^\{\{\{\s(.*?)\s\}\}\}\s`mse' => 'f_save_html(\'<pre>$1</pre>\');',
	
	// On preserve les textes a proteger
	'`\{\{\{(.*?)\}\}\}`e' => 'f_save_html(\'<code>$1</code>\');',
	
	// Filet de separation
	// <hr noshade="noshade">
	'`^\-\-\-\-\s`m' => '<hr />',
	
	// Retours a la ligne
	'`\\\\\\\\`e' => 'f_save_html(\'<br />'."\n".'\');',
	
	// Inline
	
	// Textes code
	'`::(.*?)::`e' => 'f_save_html(\'<code>$1</code>\');',
	
	// Protection des http://
	'`http\:\/\/`' => 'http:||',

	// Textes gras et italique
	'`\!\!(.*?)\!\!`' => '<strong>$1</strong>',
	'`//(.*?)//`' => '<em>$1</em>',

	// Remise des http://
	'`http\:\|\|`' => 'http://',

	// Textes grands et petits
	'`\+\+(.*?)\+\+`' => '<big>$1</big>',
	'`\-\-(.*?)\-\-`' => '<small>$1</small>',

	// Textes souligne et barres
	'`__(.*?)__`' => '<u>$1</u>',
	'`~~(.*?)~~`' => '<s>$1</s>',

	// Textes en exposant ou indice
	'`\^\^(.*?)\^\^`' => '<sup>$1</sup>',
	'`,,(.*?),,`' => '<sub>$1</sub>',

	// Formatage des textes
	'`%%([a-z0-9]+)\s?\|\s?(.*?)%%`m' => '<span class="$1">$2</span>',
	
	// Textes citation
	'`;;(.*?);;`e' => 'f_save_html(\'<cite>$1</cite>\');',

	// Les images et les documents a telercharger
	'`\{\{(.+?\/(.+?\.(?:png|jpg|gif)))\}\}`e' => 'f_save_html(\'<img src="$1" alt="$2" title="$2" />\');',
	'`\{\{(.+?\/(.+?\.pdf))\}\}`e' => 'f_save_html(\'<a href="$1" title="$2"><img src="'.QDDIR.'pdf064.jpg" alt="$2" /></a>\');',
	'`\{\{(.+?\/(.+?\.zip))\}\}`e' => 'f_save_html(\'<a href="$1" title="$2"><img src="'.QDDIR.'zip064.jpg" alt="$2" /></a>\');',
	
	// Les liens

	// E-mails (a href=mailto:)
	'`\[\[([^\s\[@]+)@([^\]\s]+)\s([^\]]+)\]\]`e' => 'f_mail_link("$1", "$2", "$3");',
	'`\[\[([^\s\[@]+)@([^\]\s]+)\]\]`e' => 'f_mail_link("$1", "$2");',
	'`(?<=\s)([^\s]+)@([^\s]+)(?=\s)`e' => 'f_mail_link("$1", "$2");',

	// Ancres (a name=)
	'`\[\[(\w+)#([^\]]+)\]\]`e' => 'f_save_html("<a name=\"$1\" title=\"$1\">$2</a>")',
	'`\[\[(\w+)#\]\]`e' => 'f_save_html("<a name=\"$1\"></a>")',

	// Liens Ancres (a href=#)
	'`\[\[(#[^\s\]]+)\s([^\]]+)\]\]`e' => 'f_save_html("<a href=\"$1\" title=\"$1\">$2</a>")',
	'`\[\[(#[^\]]+)\]\]`e' => 'f_save_html("<a href=\"$1\" title=\"$1\">$1</a>")',

	// Liens Url (a href=http)
	'`\[\[([^\s\]]+)\s([^\]]+)\]\]`e' => 'f_url_link("<a href=\"$1\" title=\"$1\" target=\"\">$2</a>", "$1")',
	'`\[\[([^\]]+)\]\]`e' => 'f_url_link("<a href=\"$1\" title=\"$1\" target=\"\">$1</a>", "$1")',
	'`(?<=\s)((?:https:/|http:/|www.)[^\s]+)(?=\s)`e' => 'f_url_link("<a href=\"$1\" title=\"$1\" target=\"\">$1</a>", "$1")',

	// Notes de bas de page
	'`\[\(([#0-9]+)(\)\()?(.*?)\)\]`e' => 'f_notes_html("$1", "$3");',

	// Blocs
	
	// Repere de debut de ligne
	'`\n`m' => "\n".QDMRK,
	
	// Blocs code et leur nettoyage
	'`^'.QDMRK.':::\s(.*?):::\s`sm' => '<pre>$1</pre>'."\n",
	'`\<pre\>\s+'.QDMRK.'`m' => '<pre>',
	'`\s+'.QDMRK.'\<\/pre\>`m' => '</pre>',
	'`(\<pre\>.*?\<\/pre\>\s?)`mse' => 'f_save_html("$1");',
	
	// Titres h2 a h6 et leur nettoyage
	'`^'.QDMRK.'\=\=\=\=\=\=\s(.*?)\=\=\=\=\=\=\s`sm' => '<h6>$1</h6>'."\n",
	'`^'.QDMRK.'\=\=\=\=\=\s(.*?)\=\=\=\=\=\s`sm' => '<h5>$1</h5>'."\n",
	'`^'.QDMRK.'\=\=\=\=\s(.*?)\=\=\=\=\s`sm' => '<h4>$1</h4>'."\n",
	'`^'.QDMRK.'\=\=\=\s(.*?)\=\=\=\s`sm' => '<h3>$1</h3>'."\n",
	'`^'.QDMRK.'\=\=\s(.*?)\=\=\s`sm' => '<h2>$1</h2>'."\n",
	'`\<h([2-6])\>\s+'.QDMRK.'`m' => '<h$1>',
	'`\s+'.QDMRK.'\<\/h([2-6])\>`m' => '</h$1>',
	
	// Listes imbriquees : a developper
	
	// Les listes imbriquees : ordonnees dans desordonnees
	// '`^'.QDMRK.'_(\*{1,4}\s?)(.*?)\n`m' => "\n".QDMRK."$1$2",

	// Les listes imbriquees : desordonnees dans ordonnees
	// '`^'.QDMRK.'_(\#{1,4}\s?)(.*?)\n`m' => "\n".QDMRK."$1$2",

	// Les listes desordonnees et leur nettoyage
	'`^'.QDMRK.'\*{4}\s?(.*?)\n`m' => "<ul>\n<ul>\n<ul>\n<ul>\n<li>$1</li>\n</ul>\n</ul>\n</ul>\n</ul>\n",
	'`^'.QDMRK.'\*{3}\s?(.*?)\n`m' => "<ul>\n<ul>\n<ul>\n<li>$1</li>\n</ul>\n</ul>\n</ul>\n",
	'`^'.QDMRK.'\*{2}\s?(.*?)\n`m' => "<ul>\n<ul>\n<li>$1</li>\n</ul>\n</ul>\n",
	'`^'.QDMRK.'\*\s?(.*?)\n`m' => "<ul>\n<li>$1</li>\n</ul>\n",
	'`\<\/ul\>\n\<\/ul\>\n\<\/ul\>\n\<ul\>\n\<ul\>\n\<ul\>`m' => "\n",
	'`\<\/ul\>\n\<\/ul\>\n\<ul\>\n\<ul\>`m' => "\n",
	'`\<\/ul\>\n\<ul\>`m' => "\n",

	// Les listes ordonnees et leur nettoyage
	'`^'.QDMRK.'\#{4}\s?(.*?)\n`m' => "<ol>\n<ol>\n<ol>\n<ol>\n<li>$1</li>\n</ol>\n</ol>\n</ol>\n</ol>\n",
	'`^'.QDMRK.'\#{3}\s?(.*?)\n`m' => "<ol>\n<ol>\n<ol>\n<li>$1</li>\n</ol>\n</ol>\n</ol>\n",
	'`^'.QDMRK.'\#{2}\s?(.*?)\n`m' => "<ol>\n<ol>\n<li>$1</li>\n</ol>\n</ol>\n",
	'`^'.QDMRK.'\#\s?(.*?)\n`m' => "<ol>\n<li>$1</li>\n</ol>\n",
	'`\<\/ol\>\n\<\/ol\>\n\<\/ol\>\n\<ol\>\n\<ol\>\n\<ol\>`m' => "\n",
	'`\<\/ol\>\n\<\/ol\>\n\<ol\>\n\<ol\>`m' => "\n",
	'`\<\/ol\>\n\<ol\>`m' => "\n",

	// Dernier petit nettoyage des retours en trop
	'`\s\<\/li\>`m' => "</li>",

	// Les listes de definition et leur nettoyage
	'`^'.QDMRK.';\s?([^:\s]+)\s?:\s?(.*)\n`m' => "<dl>\n<dt>$1</dt><dd>$2</dd>\n</dl>\n",
	'`</dl>\n<dl>`m' => "\n",
	'`\s\<\/dt\>`m' => "</dt>",
	'`\s\<\/dd\>`m' => "</dd>",

	// Les tableau (fonction specialisee)
	'`^'.QDMRK.'\{\|(.*?)\|\}`mse' => 'f_build_table("$1")',

	// Blocs citation et leur nettoyage
	'`^'.QDMRK.';;;\s(.*?);;;\s`sm' => '<blockquote>$1</blockquote>'."\n",
	'`\<blockquote\>\s+'.QDMRK.'`m' => '<blockquote>',
	'`\s+'.QDMRK.'\<\/blockquote\>`m' => '</blockquote>',

	// Les blocs div de formatage
	'`^'.QDMRK.'%%%([gdcj])\s(.*?)%%%\s`sm' => '<div class="$1">$2</div>',
	'`\<div\>\s+'.QDMRK.'`m' => "<div>\n",
	'`\s+'.QDMRK.'\<\/div\>`m' => "\n</div>",

	// Les paragraphes et leur nettoyage
	'`^'.QDMRK.'(.*?)\n`m' => "<p>$1</p>\n",
	'`\s\<\/p\>\n`m' => "</p>\n",
	'`\s\<p\>\<\/p\>\n`m' => "\n\n",

	// Dernier nettoyage
	'`'.QDMRK.'`' => "",
	'`\n+`m' => "\n");

$aMaskTable = array(
	"`".QDMRK."`m" => "",
	"`\n\|`m" => "\n<tr>|",
	"`\|\s?\n`m" => "|</tr>\n",
	"`\|\|(.*?)(?=\|)`m" => "<th>$1</th>",
	"`\|\|`m" => "\|",
	"`\|(.*?)(?=\|)`m" => "<td>$1</td>",
	"`\|`m" => "");

$aSaveHtml = array();
$aNotesHtml = array();

/*----------------------------------------------------------------------------------------------------*/
// Installation

f_install();

// Fonction d'initialisation et de gestions des noms

/** 
 * Fonction pour créer et installer les dossiers et fichiers par défaut
 * @name	f_upload()
 * @version	0101
 * --
 * @return	null		Rédirection automatique
 */
function f_install() {
	$n = 0;
	$sAccueilDft = QDDIR.QDDFPG.QDTXT;
	$sAccueilPge = QDPAGES.QDDFPG.QDTXT;
	$sAideDft = QDDIR.'Aide_Formatage'.QDTXT;
	$sAidePge = QDPAGES.'Aide_Formatage'.QDTXT;

	$n = $n + is_dir(QDPAGES);
	$n = $n + is_dir(QDMEDIAS);
	$n = $n + is_dir(QDCACH);
	$n = $n + is_dir(QDARCH);
	$n = $n + is_file($sAccueilPge);
	$n = $n + is_file($sAidePge);
	
	if ($n < 6) {
		if (!is_dir(QDPAGES)) { mkdir(QDPAGES, 0700); }
		if (!is_dir(QDMEDIAS)) { mkdir(QDMEDIAS, 0700); }
		if (!is_dir(QDCACH)) { mkdir(QDCACH, 0700); }
		if (!is_dir(QDARCH)) { mkdir(QDARCH, 0700); }
		
		$sIndex = 'index.html';
		$hIndex = f_index_tpl();
		if (!is_file(QDPAGES.$sIndex)) { f_write_b(QDPAGES.$sIndex, $hIndex); } 
		if (!is_file(QDMEDIAS.$sIndex)) { f_write_b(QDMEDIAS.$sIndex, $hIndex); } 
		if (!is_file(QDCACH.$sIndex)) { f_write_b(QDCACH.$sIndex, $hIndex); } 
		if (!is_file(QDARCH.$sIndex)) { f_write_b(QDARCH.$sIndex, $hIndex); } 
		
		if (is_file($sAccueilDft) && !is_file($sAccueilPge)) { 
			copy($sAccueilDft, $sAccueilPge); 
			f_noms(QDDFPG, QDDFPG, 1, 1);
		}
		if (is_file($sAideDft) && !is_file($sAidePge)) { 
			copy($sAideDft, $sAidePge); 
			f_noms('Aide_Formatage', 'Aide Formatage', 1, 0);
		}

	}
}

/*------------------------------------------------------------------------------------------------------------------------------------------------------*\
	Gestion des actions - Controler
\*------------------------------------------------------------------------------------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------------------------------*/
// Identification pour modes Redac ou Admin

// Gestion de la session
session_start(); 
if (isset($_GET['fin']) && $_GET['fin']) { 
	// Fin de la connexion
	session_unset();  
	session_destroy();
	$sPge = '';
	if (isset($_GET[QDPGE])) { $sPge = '?'.QDPGE.'='.$_GET[QDPGE]; }
	$uRedirect = ''.QDHOME.$sPge;
	header('Location: '.$uRedirect);
	exit();
}
$bSess = 0 + isset($_SESSION['qdmdp']);

// Identifiants et mots de passes
$sAdmin = md5(QDADMN);
$bAdmin = 0;
$sRedac = md5(QDRDAC);
$bRedac = 0;

// On test le retour du formulaire pour savoir si on est en mode admin ou redac // qdadm, qdmdp
// Sinon, si session active, on test le mot de passe pour savoir si on est en mode admin ou redac
if (isset($_POST['qdadm'])) {
	$sMdp = md5($_POST['qdmdp']);
	$bAdmin = 0 + ($sAdmin === $sMdp);
	$bRedac = 0 + ($sRedac === $sMdp);
	unset($_POST['qdadm'], $_POST['qdmdp']);
	if ($bAdmin || $bRedac) { $_SESSION['qdmdp'] = $sMdp; }
	
} else if ($bSess) {
	$sMdp = ''.$_SESSION['qdmdp'];
	$bAdmin = 0 + ($sAdmin === $sMdp);
	$bRedac = 0 + ($sRedac === $sMdp);
}

// Affichage caché du mot de passe d'urgence (en cas de perte ou oubli)
if (isset($_GET['mdp']) && $_GET['mdp'] && !$bAdmin && !$bRedac) { echo '<!--'.QDADMN.'-->'.LF; }

/*--------------------------------------------------*/
// Gestion du nom des pages publiées ou pas

$aPagesOn = array();
$aPagesOf = array();

// On récupère la liste des noms mémorisés des pages publiés, si le fichier existe
// sinon, on liste les fichiers dans le repertoire pages/
if (is_file(QDPON)) { 
	$aPagesOn = @include(QDPON); 
} else {
	$aPagesOn = f_fichiers(1);
	$sExport = '<'.'?'.'php'.LF.'return '.var_export($aPagesOn, true).';'.LF.'?'.'>';
	f_write_b(QDPON, $sExport);
}

// On récupère la liste des noms mémorisés des pages publiés, si le fichier existe
if (is_file(QDPOF)) { $aPagesOf = @include(QDPOF); }

$aPagesOn = f_sort_list_a($aPagesOn, 0, 2); // Tri croissant sur la clé
$aPagesOf = f_sort_list_a($aPagesOf, 0, 2); // Tri croissant sur la clé

/*--------------------------------------------------*/
// Recuperation des variables POST dans GET

if (isset($_POST['qdpge'])) { $_GET[QDPGE] = ''.$_POST['qdpge']; }
if (isset($_POST['qdjob'])) { $_GET[QDJOB] = (int)$_POST['qdjob']; }
if (isset($_POST['qdpub'])) { $_GET[QDPUB] = (int)$_POST['qdpub']; }
if (isset($_POST['qdrch'])) { $_GET[QDRCH] = ''.$_POST['qdrch']; }

/*--------------------------------------------------*/
// Actions d'edition avec redirection

if ($bAdmin && isset($_POST['qdcnf'])) { f_config(); }
	
if ($bAdmin && isset($_POST['qddel'])) { f_delete(); }

if (($bAdmin || $bRedac) && isset($_POST['qdupl'])) { f_upload(); }
	
if (($bAdmin || $bRedac) && isset($_POST['qdsve'])) { f_article(); }

/*--------------------------------------------------*/
// Les recherches

$aRechTags = array('\\', '::', '!!', '//', '++', '--', '__', '~~', '^^', ',,', '%%', ';;');
$aPagesRech = array();
$aTextesRech = array();
$sRecherche = '';

if (isset($_GET[QDRCH]) && !empty($_GET[QDRCH])) { $sRecherche = rawurldecode(stripslashes(''.$_GET[QDRCH])); }
if (isset($_POST['qdrch']) && !empty($_POST['qdrch'])) { $sRecherche = stripslashes(''.$_POST['qdrch']); }

if (!empty($sRecherche)) { f_recherche_c(); }

/*----------------------------------------------------------------------------------------------------*/
// Fonctions de traitement sans retour

/**
 * Fonctions de sauvegarde de la configuration utilisateur
 * @name	f_config()
 * @version	0101
 * --
 * @return	null		Rédirection automatique 
 */
function f_config() {
	global $bAdmin, $bRedac;
	$uRedirect = QDSELF.'?'.QDPGE.'='.$_POST['qdpge'].'&'.QDJOB.'=0&'.QDPUB.'='.$_POST['qdpub']; 
	$bAccueil = 0 + (QDDFPG === $_POST['qdpge']);

	if ($bAdmin) {
		// Le nouveau nom de page
		$aNom = f_clean_names($_POST['qddfnm']);
		$sPage = ''.@$aNom['doc'];
		$sNom = ''.@$aNom['nom'];
		
		if (!empty($sPage)) {
			$sCnfg = '<'.'?'.'php'.LF;
			$sCnfg .= '/'.'/'.' qkDocs - Ne pas modifier ce fichier'.LF;
			$sCnfg .= 'def'.'ine('.'"QD'.'SITE", "'.$_POST['qdsite'].'");'.LF;
			$sCnfg .= 'def'.'ine('.'"QD'.'LOGO", "'.$_POST['qdlogo'].'");'.LF;
			$sCnfg .= 'def'.'ine('.'"QD'.'ADMN", "'.$_POST['qdadmn'].'");'.LF;
			$sCnfg .= 'def'.'ine('.'"QD'.'RDAC", "'.$_POST['qdrdac'].'");'.LF;
			$sCnfg .= 'def'.'ine('.'"QD'.'DFPG", "'.$sPage.'");'.LF;
			$sCnfg .= 'def'.'ine('.'"QD'.'DFNM", "'.$sNom.'");'.LF;
			$sCnfg .= 'def'.'ine('.'"QD'.'UPMX", '.intval($_POST['qdupmx']).');'.LF;
			$sCnfg .= 'def'.'ine('.'"QD'.'HAUT", '.intval($_POST['qdhaut']).');'.LF;
			$sCnfg .= 'def'.'ine('.'"QD'.'COUL", '.(0 + $_POST['qdcoul']).');'.LF;
			$sCnfg .= 'def'.'ine('.'"QD'.'SMYL", '.(0 + $_POST['qdsmyl']).');'.LF;
			$sCnfg .= 'def'.'ine('.'"QD'.'TRGT", '.(0 + $_POST['qdtrgt']).');'.LF;
			$sCnfg .= 'def'.'ine('.'"QD'.'MSQN", '.(0 + $_POST['qdmsqn']).');'.LF;
			$sCnfg .= '?'.'>';
			$sPath = QDCNF;
			f_write_b($sPath, $sCnfg);
			
			if ($sPage !== QDDFPG) {
				$uDftOrig = QDPAGES.QDDFPG.QDTXT;
				$uDftNew = QDPAGES.$sPage.QDTXT;
				@rename($uDftOrig, $uDftNew);
			}
			
			if ($bAccueil) { $uRedirect = QDSELF.'?'.QDPGE.'='.$sPage.'&'.QDJOB.'=0&'.QDPUB.'='.$_POST['qdpub']; }
		}
	}
	
	header('Location: '.$uRedirect);
	exit();
}

/** 
 * Fonction pour rechercher les mots passés par le formulaire de recherche dans les différentes pages
 * @name	f_recherche_c()
 * @version	0102
 * --
 * @return	null		Rédirection automatique
 * Correction d'un petit bug sur les Regex qui ne prénait pas en compte les accents. Merci Petrus !
 * http://forum.macfr.com/index.php?showtopic=27004&view=findpost&p=209874
 */
function f_recherche_c() {
	global $bAdmin, $bRedac, $aPagesOn, $aPagesOf, $aPagesRech, $aTextesRech, $aRechTags, $sRecherche;
	
	$aPagesRech = array();
	$aTextesRech = array();

	$aPagesTest[QDDFPG] = QDDFNM;
	$aPagesTest = $aPagesTest + $aPagesOn;
	if ($bAdmin || $bRedac) { $aPagesTest = $aPagesTest + $aPagesOf; }
	
	if (strpos(ST.$sRecherche.ET, '"')) { $sMsq = '`[^\s\"]+[\w\s]+[^\s\"]+`i'; } else { $sMsq = '`[^\s]+`i'; }
	preg_match_all($sMsq, $sRecherche, $aRech);
	$aTextesRech = $aRech[0];
	
	foreach ($aPagesTest as $sCle => $sVal) {
		if (!isset($aPagesRech[$sCle])) {
			foreach ($aTextesRech as $sk => $sV) {
				if (preg_match('`'.$sV.'`i', $sVal)) { $aPagesRech[$sCle] = $sVal; }
			}
			$sFile = QDPAGES.$sCle.QDTXT;
			if (is_file($sFile) && !isset($aPagesRech[$sCle])) {
				$sText = stripslashes(implode('', file($sFile)));
				$sText = ST.str_replace($aRechTags, '', $sText).ET;
				foreach ($aTextesRech as $sk => $sV) {
					if (preg_match('`'.$sV.'`i', $sText)) { $aPagesRech[$sCle] = $sVal; }
				}
			}
		}
	}
}

/** 
 * Fonction pour gérer le contenu des articles suivant l'action demandée (création, modification ou supression)
 * @name	f_article()
 * @version	0101
 * --
 * @return	null		Rédirection automatique
 */
function f_article() {
	global $bAdmin, $bRedac;
	
	// Lorsqu'on valide le formulaire d'un article
	$sPage = ''.@$_POST['qdpge'];
	$nJob = 0 + $_POST['qdjob'];
	$bBup = 0 + @$_POST['qdbup'];

	$sNom = ''.@$_POST['qdnom'];
	$bPub = 0 + @$_POST['qdpub'];
	$sText = ''.@$_POST['qdtxt'];
	
	if ($sPage === QDDFPG) { $bPub = 1; }
	
	$uRedirect = QDSELF.'?'.QDPGE.'='.$sPage.'&'.QDJOB.'=0&'.QDPUB.'='.$bPub; 
	
	// Création d'un article
	if (($bAdmin || $bRedac) && ($nJob > 1) && !empty($sNom) && empty($sPage)) {
		// $sPage = f_clean_names($sNom);
		$sPage = f_noms('', $sNom, 1, $bPub);
		$sTextFile = QDPAGES.$sPage.QDTXT;
		
		if (($sPage !== QDDFPG) && !is_file($sTextFile)) {
			$bText = f_write_b($sTextFile, $sText);
			$uRedirect = QDSELF.'?'.QDPGE.'='.$sPage.'&'.QDJOB.'=0&'.QDPUB.'='.$bPub; 
		}
		
	// Suppresion d'un article
	} else if ($bAdmin && $nJob && empty($sNom) && !empty($sPage) && ($sPage !== QDDFPG)) {
		// Suppression du nom dans la liste
		f_noms($sPage, '', -1, $bPub);
		// Suppression des fichiers
		$sTextFile = QDPAGES.$sPage.QDTXT;
		$sCachFile = QDCACH.$sPage.QDPHP;
		$sArchFile = QDARCH.$sPage.QDTXT;
		if (is_file($sTextFile)) { unlink($sTextFile); }
		if (is_file($sCachFile)) { unlink($sCachFile); }
		if (is_file($sArchFile)) { unlink($sArchFile); }
		$uRedirect = QDSELF.'?'.QDPGE.'='.QDDFPG.'&'.QDJOB.'=0&'.QDPUB.'='.$bPub; 
		
	// Modification d'un article
	} else if (($bAdmin || $bRedac) && $nJob && !empty($sNom) && !empty($sPage)) {
		$sTextFile = QDPAGES.$sPage.QDTXT;
		
		// On supprime d'une liste pour ajouter à l'autre
		if (($bBup !== $bPub) && ($sPage !== QDDFPG)) {
			f_noms($sPage, '', -1, $bBup);
			f_noms('', $sNom, 1, $bPub);
		}
		
		$sPageNew = f_noms($sPage, $sNom, 1, $bPub); // On change le nom
		$sNomNew = f_noms($sPageNew, '', 0, $bPub);  // On récupère le nouveau
		$sNewFile = QDPAGES.$sPageNew.QDTXT;

		if (($sPageNew !== $sPage) && ($sPageNew !== QDDFPG) && !is_file($sNewFile)) { 
			@rename($sTextFile, $sNewFile);
			$sPage = $sPageNew; 
			$sTextFile = $sNewFile;
		}

		$bArch = f_archive($sPage);
		$bText = f_write_b($sTextFile, $sText);

		$uRedirect = QDSELF.'?'.QDPGE.'='.$sPage.'&'.QDJOB.'=0&'.QDPUB.'='.$bPub; 
	}
	
	// Enregistrement du cache
	if (is_file($sTextFile)) { $bCach = f_cache($sPage, $sNom, $sText, $bPub); }
	
	header('Location: '.$uRedirect);
	exit();
}

/*--------------------------------------------------*/

/** 
 * Fonction pour enregistrer un fichier de cache après validation du formulaire de saisie
 * @name	f_cache()
 * @version	0101
 * --
 * @param	string	$sPage	La page à mettre en cache
 * @param	string	$sNom	Le nom de la pag à mettre en cache
 * @param	string	$sText	Le texte à mettre en cache
 * @return	boolean	$bCach	Indique si l'enregistrement s'est bien passé
 */
function f_cache($sPage, $sNom, $sText, $bPub) {
	$sNom = f_noms($sPage, '', 0, $bPub); 
	$sCont = stripslashes($sText);
	// $sCont = f_clean_typo_html(f_build_cont(LF.$sCont));
	$sCont = f_build_cont(LF.$sCont);

	if (QDMSQN) { $sNom = preg_replace('`^[0-9]+[^a-z]?\s?(.*)`i', "$1", $sNom); }
	$hPage = f_cont_tpl($sCont, $sNom);
	
	$hCach =  '<'.'?'.'php'.LF.'ret'.'urn '.'<'.'<'.'<'.'QD'.'_HTML'.LF.$hPage.LF.'QD'.'_HTML;'.LF.'?'.'>';
	$sCachFile = QDCACH.$sPage.QDPHP;
	$bCach = f_write_b($sCachFile, $hCach);

	return $bCach;
}

/** 
 * Fonction pour enregistrer une copie d'archive de la dernière version précédente de la page
 * @name	f_archive()
 * @version	0101
 * --
 * @param	string	$sPage	La page à sauvegarder
 * @return	boolean	$bCopy	Indique si la copie s'est bien passé
 */
function f_archive($sPage) {
	$sTextFile = QDPAGES.$sPage.QDTXT;
	$sArchFile = QDARCH.$sPage.QDTXT;
	$bArch = copy($sTextFile, $sArchFile);

	return $bArch;
}

/*--------------------------------------------------*/
// Fonctions de travail avec les fichiers medias (listage, téléchargement et supression)

/** 
 * Fonction pour retourner le code Html (menu liste et popup-menu) des fichiers suivant le type demandé
 * @name	f_medias()
 * @version	0101
 * --
 * @param	string	$sType	Valeur indiquant les types de fichiers à lister
 * @return	array	$aRes	Liste Html des fichiers listés
 */
function f_medias($sType) {
	// Liste des fichiers dans le repertoire courrant
	$aFiles = f_read_dir(QDMEDIAS);
	// Filtrage des fichiers pour ne garder que ceux qui ont une extension sType
	$aDocs = f_filter_list($aFiles, $sType);

	// Tri croissant de la liste des noms
	$aDocs = f_sort_list_a($aDocs, 0, 1);

	// Recuperation des liens
	$aLiens = array_keys($aDocs);
	// Recuperation des noms
	$aNoms = array_values($aDocs);
	
	// Construction du menu avec les liens d'affichage
	$hMediasList = f_htm_doc_list($aLiens, $aNoms);
	$hMediasPop = f_htm_doc_opts($aLiens, $aNoms);
	
	$aRes = array($hMediasList, $hMediasPop);
	return $aRes;
}

/** 
 * Fonction pour télécharger de nouveaux fichiers multimédias (jpg, png, pdf et zip)
 * @name	f_upload()
 * @version	0102
 * --
 * @return	null		Rédirection automatique
 */
function f_upload() {
	global $bAdmin, $bRedac;
	$uRedirect = QDSELF.'?'.QDPGE.'='.$_POST['qdpge'].'&'.QDJOB.'='.$_POST['qdjob'].'&'.QDPUB.'='.$_POST['qdpub']; 
	
	// Correction de bug signalé par BorakLeRouge sur MacFr :
	// http://forum.macfr.com/index.php?showtopic=27004&view=findpost&p=209781
	if (($bAdmin || $bRedac) && !$_FILES['qddoc']['error']) {

		$sNom = $_FILES['qddoc']['name'];
		$aNom = f_clean_names($sNom, 1);
		if (!empty($aNom)) {
			$sPage = $aNom['doc'];
			$sNom = $aNom['nom'];
		}

		$nMax = intval(QDMAX * 1000000);
		if (preg_match('`(?:pdf|zip)$`', $sNom)) { $nMax = intval(QDUPMX * 1000000); }

		$sTemp = $_FILES['qddoc']['tmp_name'];
		$sType = $_FILES['qddoc']['type'];
		$sTaille = 0 + $_FILES['qddoc']['size'];
		$sErreur = $_FILES['qddoc']['error'];
		$bTaille = 0 + ($sTaille < $nMax);
		$sTest = $_POST['qdtyp'];
		$bType = 0 + (strpos($sTest, $sType));
		$pDest = QDMEDIAS.$sNom;
		
		if (!is_file($pDest) && $bTaille && $bType) { copy($sTemp, $pDest); }
	}
	
	header('Location: '.$uRedirect);
	exit();
}

/** 
 * Fonction pour supprimer un fichier multimédia (jpg, png, pdf et zip)
 * @name	f_delete()
 * @version	0101
 * --
 * @return	null		Rédirection automatique
 */
function f_delete() {
	global $bAdmin, $bRedac;
	$uRedirect = QDSELF.'?'.QDPGE.'='.$_POST['qdpge'].'&'.QDJOB.'='.$_POST['qdjob'].'&'.QDPUB.'='.$_POST['qdpub']; 

	if ($bAdmin) {
		$sDoc = $_POST['qddocdel'];
		$pDoc = QDMEDIAS.$sDoc;
		if (is_file($pDoc)) { unlink($pDoc); }
	}
	
	header('Location: '.$uRedirect);
	exit();
}

/*--------------------------------------------------*/
// Fonctions de récupération des fichiers texte et de gestions des noms

/**
 * Fonction pour récupérer la liste des fichiers textes présents dans le dossier pages/
 * @name	f_fichiers()
 * @version	0101
 * --
 * @return	null		Rédirection automatique
 */
function f_fichiers() {
	$aFiles = f_read_dir(QDPAGES);
	// Filtrage des fichiers pour ne garder que ceux qui ont une extension ".txt"
	$aFichiers = f_filter_list($aFiles, '`(\\'.QDTXT.')$`', '`('.QDDFPG.')`');
	
	$nVrs = (int)PHP_VERSION;
	// Recuperation des pages et suppression de l'extension
	$aPages = str_replace(QDTXT, '', array_keys($aFichiers));
	// Recupération des noms et suppression de l'extension pour affichage
	$aNoms = str_replace(QDTXT, '', array_values($aFichiers));
	
	$aFichiers = array();

	if ($nVrs > 4) {
		// http://fr.php.net/manual/fr/function.array-combine.php
		$aFichiers = array_combine($aPages, $aNoms);
	} else {
		for ($i = 0; $i < count($aPages); $i++) {
			$sPage = $aPages[$i];
			$sNom = $aNoms[$i];
			$aFichiers[$sPage] = $sNom;
		}
	}
	
	return $aFichiers;
}

/**
 * Fonction pour gérer le nom des pages (longueur illimité et accents supportés)
 * @name	f_noms()
 * @version	0101
 * --
 * @param	string	$sPage	Le nom de la page comme varialbe de travail
 * @param	string	$sNom	Le nom original de la page, pour l'affichage
 * @param	number	$nJob	Le type de traitement à effecture : > 0 = ajout ou modification ; < 0 = suppresion ; 0 = retour de valeurs.
 * @param	boolean	$bPage	Indique sur quelles pages travailler : 1 ou true = pages publiées ; 0 (zéro) ou false = pages brouillons
 * @return	string	divers	Retour de la clé ou du nom de la page
 */
function f_noms($sPage='', $sNom='', $nJob=0, $bPage=1) {
	global $aPagesOn, $aPagesOf;
	
	// Correction de bug signalé par BorakLeRouge sur MacFr :
	// http://forum.macfr.com/index.php?showtopic=27004&view=findpost&p=209837
	
	if ($bPage) {
		$aPages = $aPagesOn;
		$sFichier = QDPON;
	} else {
		$aPages = $aPagesOf;
		$sFichier = QDPOF;
	}

	// Si nJob > 0 : ajout ou modification du nom
	// Si nJob < 0 : suppresion du nom
	// Sinon, on retourne le nom demandé ou la liste des pages et des noms
	if ($nJob > 0) {
		if ($sPage === QDDFPG) { return QDDFPG; }
		
		// Modif du nom : on supprime l'ancien avant de mémoriser le nouveau
		if (!empty($sPage)) { unset($aPages[$sPage]); }

		// Le nouveau nom de page
		$aNom = f_clean_names($sNom);
		if (!empty($aNom)) {
			$sPage = $aNom['doc'];
			$sNom = $aNom['nom'];
		}

		// Si le fichier existe déjà, on ajout un numéro à la fin tout en conservant la longueur maximum autorisée
		$sFile = QDPAGES.$sPage.QDTXT;
		if (is_file($sFile) && isset($aPages[$sPage])) {
			$i = 0;
			while (is_file($sFile)) {
				$i++;
				$nLen = strlen(''.$i);
				$sNew = substr($sPage, 0, -$nLen).$i;
				$sFile = QDPAGES.$sNew.QDTXT;
			}
			$sPage = $sNew;
		}
		$aPages[$sPage] = $sNom; // htmlspecialchars($sNom, ENT_QUOTES, "UTF-8");
		
		$aPages = f_sort_list_a($aPages, 0, 2); // Tri croissant sur la clé
		$sExport = '<'.'?'.'php'.LF.'return '.var_export($aPages, true).';'.LF.'?'.'>';
		f_write_b($sFichier, $sExport);
		
		// Mise à jour des listes
		if ($bPage) { $aPagesOn = $aPages; } else { $aPagesOf = $aPages; }
	
		return $sPage; // On retourne la nouvelle page
			
	} else if ($nJob < 0) {
		// Supprimer nom
		unset($aPages[$sPage]);
		$aPages = f_sort_list_a($aPages, 0, 2); // Tri croissant sur la clé
		$sExport = '<'.'?'.'php'.LF.'return '.var_export($aPages, true).';'.LF.'?'.'>';
		f_write_b($sFichier, $sExport);
		
		// Mise à jour des listes
		if ($bPage) { $aPagesOn = $aPages; } else { $aPagesOf = $aPages; }
	
	} else {
		// Retourne valeurs
		if (empty($sPage) || !isset($aPages[$sPage]) || ($sPage === QDDFPG)) {
			return QDDFNM; // on retourne le nom de la page d'accueil
		} else {
			return $aPages[$sPage]; // on retourne le nom
		}
	}
}

/*------------------------------------------------------------------------------------------------------------------------------------------------------*\
	Gestion des contenus - Model
\*------------------------------------------------------------------------------------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------------------------------*/
// Fonctions de formatage des contenus

/**
 * Fonction pour formater les images (non utilisé pour le moment)
 * @name	f_img_txt()
 * @version	0101
 * --
 * @param	string	$sText	Le lien html
 * @return	string	$sId		Un identifiant a remplacer au moment du rendu final
 */
function f_img_txt($sText) {
	// On corrige les liens
	// $sText = str_replace(array('http:/', '///'), array('http://', '//'), $sText);
	
	$sId = f_save_html($sText);
	return $sId;
}

/**
 * Fonction pour formater des adresses-liens e-mails
 * @name	f_mail_link()
 * @version	0101
 * --
 * @param	string	$sNom	Le nom de l'adresse e-mail
 * @param	string	$sFai	Le fournisseur d'accès de l'adresse e-mail
 * @param	string	$sText	Le texte à afficher
 * @return	string	$sId		Un identifiant a remplacer au moment du rendu final
 */
function f_mail_link($sNom, $sFai, $sTxt='') {
	if (empty($sTxt)) {
		$sHtml = f_crypt_html($sNom.'[@]'.$sFai, 1);
	} else {
		$sHtml = $sTxt;
	}
	$sHexa = f_crypt_hexa($sNom.'@'.$sFai);
	$uEmail = f_crypt_html('mailto:'.$sHexa);
	$hEmail = '<a href="'.$uEmail.'" title="'.$sNom.'">'.$sHtml.'</a>';
	$sId = f_save_html($hEmail);
	return $sId;
}


/**
 * Fonction pour formater des adresses-liens e-mails
 * @name	f_url_link()
 * @version	0101
 * --
 * @param	string	$sText	Le lien html
 * @param	string	$sUrl	L'adresse Url
 * @return	string	$sId		Un identifiant a remplacer au moment du rendu final
 */
function f_url_link($sText, $sUrl) {
	// On corrige les liens
	// $sText = str_replace(array('http:/', '///'), array('http://', '//'), $sText);
	
	// Si l'ouverture dans une nouvelle fenetre, alors on ajoute le target _blank
	if (QDTRGT && preg_match('`^(?:https:|http:|www.)`', $sUrl)) {
		$aHost = explode(':', $_SERVER['HTTP_HOST']);
		$sHost = $aHost[0];
		$sUrl = str_replace(array('https:', 'http:', '/'), array('', '', ''), $sUrl);
		$aUrl = parse_url($sUrl);
		$sUrl = '-'.implode('-', $aUrl);
		if ((strpos($sUrl, $sHost) === false)) { $sText = str_replace('target=""', 'target="_blank"', $sText); }
	}

	$sId = f_save_html($sText);
	return $sId;
}

/**
 * Fonction pour formater des notes de bas de page
 * @name	f_notes_html()
 * @version	0101
 * --
 * @param	string	$sNro	Le numéro de la note
 * @param	string	$sText	Le texte de la note
 * @return	string	$sId		Un identifiant a remplacer au moment du rendu final
 */
function f_notes_html($sNro=0, $sText='') {
	global $aNotesHtml;

	$aNotesSort = f_sort_list_a($aNotesHtml, 0, 2);

	if (strpos(ST.$sNro.ET, '#')) {
		$aKeys = array_keys($aNotesSort);
		$nNro = end($aKeys);
		$nNbr = count($aKeys);
		if (($nNbr > 0) && ($nNbr < $nNro)) {
			$nNro = 1;
			while (isset($aNotesSort[$nNro])) {
				$nNro++;
			}
		} else {
			$nNbr++;
			$nNro = $nNbr;
		}
	}

	if (!isset($nNro)) { $nNro = (int)$sNro; }
	if ($nNro === 0) { $nNro = 1; }

	if (!empty($sText)) {
		$hNote = '<a href="#texte_'.$nNro.'" name="note_'.$nNro.'" title="texte '.$nNro.'">['.$nNro.']</a>&nbsp;'.$sText.'<br />'.LF;
		$aNotesSort[$nNro] = $hNote;
	}
	$aNotesHtml = f_sort_list_a($aNotesSort, 0, 2);

	$hLien = '&nbsp;<a href="#note_'.$nNro.'" name="texte_'.$nNro.'" title="note '.$nNro.'">['.$nNro.']</a>';
	$sId = f_save_html($hLien, 0);
	return $sId;
}

/**
 * Fonction qui returne le code Html des tableaux apres traitement des balises saisies
 * @name	f_build_table()
 * @version	0101
 * --
 * @param	string	$sText	Les balises saisies pour le formatage d'un tableau
 * @return	string	$sRes	Code Html des tableaux a afficher
 */
function f_build_table($sText) {
	global $aMaskTable;
	$sRes = '<table>'.preg_replace(array_keys($aMaskTable), array_values($aMaskTable), $sText).'</table>';
	return $sRes;
}

/*--------------------------------------------------*/

/**
 * Fonction qui returne un identifian des codes proteges a remplacer au moment du rendu final
 * @name	f_save_html()
 * @version	0101
 * --
 * @param	string	$sText	La balise ou le code a proteger
 * @return	string	$sId		Un identifiant a remplacer au moment du rendu final
 */
function f_save_html($sText, $bMark=1) {
	global $aSaveHtml;
	
	// On corrige les liens
	// $sText = str_replace(array('http:/', '///'), array('http://', '//'), $sText);
	// On mémorise les liens
	$nId = count($aSaveHtml);
	$sId = QDSVE.substr('000000'.$nId, -6).QDSVE;
	if ($bMark) { $sText = str_replace(QDMRK, '', $sText); }
	$aSaveHtml[$sId] = $sText;
	return $sId;
}

/**
 * Fonction qui returne le code Html du formatage du texte saisi
 * @name	f_build_cont()
 * @version	0101
 * --
 * @param	string	$sText	Le contenu brut saisie a convertir et formater en Html
 * @return	string	$sRes	Code Html du contenu formate
 */
function f_build_cont($sText) {
	global $aSaveHtml, $aNotesHtml, $aMaskTags, $aSmileys;

	$sRes = htmlspecialchars($sText, ENT_QUOTES, "UTF-8");
	$sRes = str_replace(chr(36), '&#036;', $sRes); // chr(36) = '$'
	
	// Les balises protégées et les notes de bas de page
	$aSaveHtml = array();
	$aNotesHtml = array();
	
	$sRes = preg_replace(array_keys($aMaskTags), array_values($aMaskTags), $sRes);
	if (QDSMYL) { $sRes = preg_replace(array_keys($aSmileys), array_values($aSmileys), $sRes); }
	
	if (count($aNotesHtml) > 0) {
		$aNotesHtml[0] = '<p class="notes">'.LF;
		$aNotesHtml[] = '</p>'.LF;
		$aNotesSort = f_sort_list_a($aNotesHtml, 0, 2);
		$sRes .= implode('', $aNotesSort);
	}
	
	$aSaveSort = f_sort_list_a($aSaveHtml, 1, 2);
	$sRes = str_replace(array_keys($aSaveSort), array_values($aSaveSort), $sRes);
	
	return $sRes;
}

/*------------------------------------------------------------------------------------------------------------------------------------------------------*\
	Gestion de l'affichage - Vue
\*------------------------------------------------------------------------------------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------------------------------*/
// Fonction pour générer des codes Html (menu listes et popup-menus)

/** 
 * Fonction pour générer une liste de liens Html (menu)
 * @name	f_htm_link_list()
 * @version	0101
 * --
 * @param	array	$aLiens	La liste des liens à lister
 * @param	array	$aNoms	La liste des noms à lister
 * @param	string	$sDefaut	Elément qui est selectionné par défaut
 * @param	boolean	$bEdit	Indique si l'élément doit être édité (1 = oui ; 0 = non)
 * @param	string	$uUrl	Url de base pour tous les liens
 * @param	string	$sVar	Variable pour l'affichage des pages
 * @param	string	$sJob	Variable pour les actions à effectuer
 * @param	string	$sTag	Balise du type de liste "ul" ou "ol"
 * @return	string	$sRes	Code Html de la liste des liens
 */
function f_htm_link_list($aLiens, $aNoms, $sDefaut='', $nJob=0, $bPub=0, $bRch=1, $uUrl='', $sVar='', $sJob='', $sPub='', $sTag='ul') {
	global $bAdmin, $bRedac, $sRecherche;
	
	if (empty($uUrl)) { $uUrl = QDSELF; }
	if (empty($sVar)) { $sVar = QDPGE; }
	if (empty($sJob)) { $sJob = QDJOB; }
	if (empty($sPub)) { $sPub = QDPUB; }
	$sDftPage = QDDFPG;
	$sDftNom = QDDFNM;
	$sRch = '&'.QDRCH.'='.rawurlencode($sRecherche); // @$_GET[QDRCH];
	if ($bRch) { $sRch = ''; }
	$aDft = array('', 'sel');
	$aRes = array();
	$aRes[] = '<'.$sTag.'>';
	if ($bAdmin || $bRedac) {
		if ($bPub && $bRch) {
			$aRes[] = '<li class="'.$aDft[$sDftPage===$sDefaut].'"><a href="'.$uUrl.'?'.$sVar.'='.$sDftPage.'&'.$sJob.'='.$nJob.'&'.$sPub.'=1" title="'.$sDftNom.'">'.$sDftNom.'</a></li>';
		}
		for ($i = 0; $i < count($aLiens); $i++) {
			$sKey = $aLiens[$i];
			$sVal = $aNoms[$i];
			if (QDMSQN) { $sVal = preg_replace('`^[0-9]+[^a-z]?\s?(.*)`i', "$1", $sVal); }
			$aRes[] = '<li class="'.$aDft[$sKey===$sDefaut].'"><a href="'.$uUrl.'?'.$sVar.'='.$sKey.'&'.$sJob.'='.$nJob.'&'.$sPub.'='.$bPub.$sRch.'" title="'.$sVal.'">'.$sVal.'</a></li>';
		}
	} else {
		if ($bRch) {
			$aRes[] = '<li class="'.$aDft[$sDftPage===$sDefaut].'"><a href="'.$uUrl.'?'.$sVar.'='.$sDftPage.'" title="'.$sDftNom.'">'.$sDftNom.'</a></li>';
		}
		for ($i = 0; $i < count($aLiens); $i++) {
			$sKey = $aLiens[$i];
			$sVal = $aNoms[$i];
			if (QDMSQN) { $sVal = preg_replace('`^[0-9]+[^a-z]?\s?(.*)`i', "$1", $sVal); }
			$aRes[] = '<li class="'.$aDft[$sKey===$sDefaut].'"><a href="'.$uUrl.'?'.$sVar.'='.$sKey.$sRch.'" title="'.$sVal.'">'.$sVal.'</a></li>';
		}
	}
	$aRes[] = '</'.$sTag.'>';
	$sRes = implode(LF, $aRes).LF;
	return $sRes;
}

/** 
 * Fonction pour générer une liste de liens Html (menu)
 * @name	f_htm_doc_list()
 * @version	0101
 * --
 * @param	array	$aLiens	La liste des lians à lister
 * @param	array	$aNoms	La liste des noms à lister
 * @param	boolean	$bJvSc	Indique s'il faut utiliser du code JavaScript (1 = oui ; 0 = non)
 * @param	string	$sTag	Balise du type de liste "ul" ou "ol"
 * @return	string	$sRes	Code Html de la liste des liens
 */
function f_htm_doc_list($aLiens, $aNoms, $bJvSc=1, $sTag='ul') {
	$aRes = array();
	$aRes[] = '<'.$sTag.'>';
	for ($i = 0; $i < count($aLiens); $i++) {
		$sKey = $aLiens[$i];
		$sVal = $aNoms[$i];
		if ($bJvSc) {
			$aRes[] = '<li class="qdimg">
<a href="'.QDMEDIAS.$sKey.'" title="'.$sVal.'" rel="'.QDMEDIAS.$sKey.'" onclick="f_mktag(this, \'{{\', \'}}\', \'qdtxt\', 1, 0); return false;" onmouseover="f_prevu(this, \'imgprevisu\'); return false;">'.$sVal.'</a>
</li>';
		} else {
			$aRes[] = '<li class="qdimg">
<a href="'.QDMEDIAS.$sKey.'" title="'.$sVal.'">'.$sVal.'</a>
<div class="qdimg">{'.QDMEDIAS.$sKey.'}<br /><img src="'.QDMEDIAS.$sKey.'" alt="'.$sVal.'" /></div>
</li>';
		}
	}
	$aRes[] = '</'.$sTag.'>';
	$sRes = implode(LF, $aRes).LF;
	return $sRes;
}

/*--------------------------------------------------*/

/** 
 * Fonction pour générer le code Html des options d'un popup-menu (balise select)
 * @name	f_htm_doc_opts()
 * @version	0102
 * --
 * @param	array	$aVals	La liste des valeurs à lister
 * @param	array	$aLibs	La liste des libellés à lister
 * @param	string	$sSel	Valeur sélectionnée, si identique à item de la liste, alors elle sera sélectionnée
 * @param	boolean	$bVal	Valeur qui defini le type d'options à générer : 0 (zero) = sans valeurs ; defaut 1 = avec valeurs.
 * @param	boolean	$bVid	Valeur qui defini si le premier element est vide : 0 (zero) = non ; defaut 1 = oui.
 * @return	string	$sRes	Code Html des options
 */
function f_htm_doc_opts($aVals, $aLibs, $sSel='', $bVal=1, $bVid=1) {
	// Correction de bug signalé par BorakLeRouge sur MacFr :
	// http://forum.macfr.com/index.php?showtopic=27004&view=findpost&p=209781

	$aRes = array();
	$aSel = array('', ' selected="selected"');
	if ($bVal) {
		if ($bVid) { $aRes[] = '<option value="">&nbsp;</option>'; }
		for ($i = 0; $i < count($aVals); $i++) {
			$sVal = $aVals[$i];
			$sLib = $aLibs[$i];
			$aRes[] = '<option value="'.$sVal.'"'.$aSel[$sVal==$sSel].'>'.$sLib.'</option>';
		}
	} else {
		if ($bVid) { $aRes[] = '<option>&nbsp;</option>'; }
		for ($i = 0; $i < count($aVals); $i++) {
			$sVal = $aVals[$i];
			$sLib = $aLibs[$i];
			$aRes[] = '<option'.$aSel[$sVal==$sSel].'>'.$sLib.'</option>';
		}
	}
	$sRes = implode(LF, $aRes).LF;
	return $sRes;
}

/*----------------------------------------------------------------------------------------------------*/
// Fonctions principales de travail et d'affichage

/**
 * Fonction pour retourner le titre de la fenêtre
 * @name	f_titre()
 * @version	0101
 * --
 * @return	null		Rédirection automatique
 */
function f_titre() {
	if (isset($_GET[QDPGE]) && !empty($_GET[QDPGE])) {
		if (isset($_GET[QDPUB])) { $bPub = 0 + $_GET[QDPUB]; } else { $bPub = 1; }
		$sPage = $_GET[QDPGE];
		$sNom = f_noms($sPage, '', 0, $bPub);
	} else {
		$sNom = QDDFNM;
	}
	$sTitre = QDSITE.' - '.$sNom;
	return $sTitre;
}

/*--------------------------------------------------*/

/** 
 * Fonction pour retourner le code Html du bandeau de tête du site
 * @name	f_tete()
 * @version	0101
 * --
  * @return	string	$hTete	Code Html du bandeau de tête du site
 */
function f_tete() {
	$hTete = f_tete_tpl();
	return $hTete;
}

/*--------------------------------------------------*/

/** 
 * Fonction pour générer le menu de navigation entre les pages
 * @name	f_menu()
 * @version	0101
 * --
  * @return	string	$hMenu	Code Html du menu
 */
function f_menu() {
	global $bAdmin, $bRedac, $aPagesOn, $aPagesOf, $aPagesRech, $sRecherche;

	// On récupère la valeur de la variable "pub" si elle existe
	if (isset($_GET[QDPUB])) {
		$bPub = (int)$_GET[QDPUB];
	} else {
		$bPub = 1;
	}
	
	// On récupère la valeur de la variable "pge" si elle existe 
	if (isset($_GET[QDPGE]) && !empty($_GET[QDPGE])) {
		$sPage = $_GET[QDPGE];
	} else {
		$sPage = QDDFPG;
	}
	
	// On récupère la valeur de l'action à efféctuer si elle existe
	if (isset($_GET[QDJOB])) {
		$nJob = 0 + $_GET[QDJOB];
	} else {
		$nJob = 0;
	}
	$bJob = 0 + ($nJob > 0);
	
	// Affichage du bloc de recherche
	if ($bJob) {
		$hRech = '';
	} else if (empty($aPagesRech)) {
		$sRech = '';
		if (!empty($sRecherche)) { $sRech = 'Aucune occurrence trouvée...'; }
		$hRech = f_rech_tpl($sRech, $sPage, $nJob, $bPub);
	} else {
		$aLiensRech = array_keys($aPagesRech);
		$aNomsRech = array_values($aPagesRech);
		$sRech = f_htm_link_list($aLiensRech, $aNomsRech, $sPage, $nJob, $bPub, 0);
		$hRech = f_rech_tpl($sRech, $sPage, $nJob, $bPub);
	}
	
	$hMenu = '';
	
	// Recuperation des pages
	$aLiensOn = array_keys($aPagesOn);
	// Recuperation des noms
	$aNomsOn = array_values($aPagesOn);
	
	// Si mode admin et job > 0
	if ($bAdmin || $bRedac) {

		// Construction du menu pages avec les liens d'affichage
		$sMenu = f_htm_link_list($aLiensOn, $aNomsOn, $sPage, $bJob, 1);
		$hMenu = f_menu_tpl($sMenu, 'Pages', 'menupages');
		
		// Recuperation des brouillons
		$aLiensOf = array_keys($aPagesOf);
		// Recuperation des noms
		$aNomsOf = array_values($aPagesOf);
	
		// Construction du menu brouillons avec les liens d'affichage
		$sMenu = f_htm_link_list($aLiensOf, $aNomsOf, $sPage, $bJob, 0);
		$hMenu .= f_menu_tpl($sMenu, 'Brouillons', 'menubrouillons');
		
		// Recherche
		$hMenu .= $hRech;
		
		if ($bJob) {
			// Imges
			$sImgTyp = '(\\'.QDJPG.'|\\'.QDPNG.'|\\'.QDGIF.')';
			$sImgUpl = '('.QDJPGMT.'|'.QDPNGMT.'|'.QDGIFMT.')';
			$aImgs = f_medias('`'.$sImgTyp.'$`');
			$hImgLink = $aImgs[0];
			$hImgOpt = $aImgs[1];
			
			// Documents
			$sDocTyp = '(\\'.QDPDF.'|\\'.QDZIP.')';
			$sDocUpl = '('.QDPDFMT.'|'.QDZIPMT.')';
			$aDocs = f_medias('`'.$sDocTyp.'$`');
			$hDocLink = $aDocs[0];
			$hDocOpt = $aDocs[1];
	
			$hMenu .= f_img_tpl($sPage, $nJob, $bPub, $sImgUpl, $hImgLink, $hImgOpt);
			$hMenu .= f_doc_tpl($sPage, $nJob, $bPub, $sDocUpl , $hDocLink, $hDocOpt);
		}

	} else {
	
		// Construction du menu avec les liens d'affichage
		$sMenu = f_htm_link_list($aLiensOn, $aNomsOn, $sPage, $bJob, 1);
		$hMenu = f_menu_tpl($sMenu);
	
		// Recherche
		$hMenu .= $hRech;
	}
	
	return str_replace(LF.LF, LF, $hMenu);
}

/*--------------------------------------------------*/

/** 
 * Fonction pour retourner le contenu de la page demandée dans l'Url
 * @name	f_page()
 * @version	0102
 * --
 * @return	string	$hPage	Code Html du contenu de la page
 */
function f_page() {
	global $bAdmin, $bRedac, $aTextesRech, $sRecherche;

	// On récupère la valeur de la variable "pub" si elle existe
	if (isset($_GET[QDPUB])) {
		$bPub = 0 + $_GET[QDPUB];
	} else {
		$bPub = 0;
	}
	
	// On récupère la valeur de la variable "pge" si elle existe
	if (isset($_GET[QDPGE]) && !empty($_GET[QDPGE])) {
		$sPage = $_GET[QDPGE];
		$sNom = f_noms($sPage, '', 0, $bPub);
	} else {
		$sPage = QDDFPG;
		$sNom = QDDFNM;
	}
	
	// On récupère le contenu du fichier s'il existe, sinon on affiche un message
	// Correction d'inclusion Xss signalé par Petrus sur MacFr : 
	// http://forum.macfr.com/index.php?showtopic=27004&view=findpost&p=209784
	$sFile = QDPAGES.$sPage.QDTXT;
	if (is_file($sFile) && !empty($sNom)) {
		$sCont = stripslashes(implode('', file($sFile)));
	} else {
		$sNom = 'Page introuvable...';
		$sCont = '[[index.php !!Retour à l\'accueil!!]]';
	}
	
	// On récupère la valeur de l'action à efféctuer si elle existe
	if (isset($_GET[QDJOB])) {
		$nJob = 0 + $_GET[QDJOB];
	} else {
		$nJob = 0;
	}
	
	// Fichier cache
	$sCach = QDCACH.$sPage.QDPHP;

	// Si on est en mode adminsitrateur on peut éditer les contenus, sinon on les affiche
	// Si action inférieur à 0, alors config, si supérieur à 1, alors nouvelle page, 
	// si égale à 1, alors édition de la page en cours, sinon affichage de la page en cours
	if ($bAdmin && $nJob < 0) {
		$hPage = f_config_tpl($sPage, $nJob, $bPub);

	} else if (($bAdmin || $bRedac) && $nJob > 1) {
		$hPage = f_article_tpl('', '', $nJob, 0, '');

	} else if (($bAdmin || $bRedac) && $nJob) {
		$hPage = f_article_tpl($sPage, $sNom, $nJob, $bPub, $sCont);
		
	} else {
		if (is_file($sCach)) {
			$hPage = include($sCach);
		
		} else {
			// $sCont = f_clean_typo_html(f_build_cont(LF.$sCont));
			$sCont = f_build_cont(LF.$sCont);
			if (QDMSQN) { $sNom = preg_replace('`^[0-9]+[^a-z]?\s?(.*)`i', "$1", $sNom); }
			$hPage = f_cont_tpl($sCont, $sNom);
		}
	}

	// Recherche
	if (!empty($aTextesRech)) {
		$sRmp = '>$1<span class="rch">$2</span>$3<';
		foreach ($aTextesRech as $sK => $sV) {
			$sMsq = '`\>([^\<]*)('.$sV.')+([^\<]*)\<`i';
			$hPage = preg_replace($sMsq, $sRmp, $hPage);
		}
	}

	// Contenu de la page à afficher, pas de "include($sPage)' pour eviter d'eventuels hacks; 
	return str_replace(LF.LF, LF, $hPage);
}

/*--------------------------------------------------*/

/** 
 * Fonction pour retourner le formulaire de connexion et d'adminsitration
 * @name	f_admin()
 * @version	0101
 * --
 * @return	string	$hForm	Code Html du formulaire d'administration
 */
function f_admin() {
	global $bAdmin, $bRedac;

	// On récupère la valeur de la variable "pub" si elle existe
	if (isset($_GET[QDPUB])) {
		$bPub = (int)$_GET[QDPUB];
	} else {
		$bPub = 1;
	}
	
	// On récupère la valeur de la variable "pge" si elle existe
	if (isset($_GET[QDPGE]) && !empty($_GET[QDPGE])) {
		$sPage = $_GET[QDPGE];
	} else {
		$sPage = QDDFPG;
	}
	
	// On récupère la valeur de l'action à efféctuer si elle existe
	if (isset($_GET[QDJOB])) {
		$nJob = 0 + $_GET[QDJOB];
	} else {
		$nJob = 0;
	}
	
	$hForm = f_admin_tpl($sPage, $nJob, $bPub);
	
	return $hForm;
}

/*--------------------------------------------------*/

/** 
 * Fonction pour retourner la signature du site
 * @name	f_sign()
 * @version	0101
 * --
 * @return	string	$hSign	Code Html de la signature du site
 */
function f_sign() {
	// On récupère la valeur de la variable "pge" si elle existe
	if (isset($_GET[QDPGE]) && !empty($_GET[QDPGE])) {
		$sPage = $_GET[QDPGE];
	} else {
		$sPage = QDDFPG;
	}

	$hSign = f_sign_tpl($sPage);
	
	return $hSign;
}

/*--------------------------------------------------*/

/** 
 * Fonction pour retourner le contenu de debugage si option active
 * @name	f_debug()
 * @version	0101
 * --
 * @return	string	$aDbg	Tableau contenant les infos de debugage
 */
function f_debug() {
	global $bDbg, $aDbg;
	if ($bDbg) { return '<pre>'.print_r($aDbg, true).'</pre>'; } else { return ''; }
}

/*--------------------------------------------------*/
// Fonctions de modèles Html (templates)

/** 
 * Fonction pour retourner le code Html du bandeau de tête du site
 * @name	f_tete_tpl()
 * @version	0101
 * --
 * @return	string	$hTete	Code Html du bandeau de tête du site
 */
function f_tete_tpl() {
	$sNom = QDSITE;
	$sHome = QDHOME;
	$sLogo = QDLOGO;
	if (empty($sLogo)) {
		$hTete = <<<QD_HTML_TPL
<h1><a href="{$sHome}" title="{$sNom}">{$sNom}</a></h1>

QD_HTML_TPL;
	} else {
		$hTete = <<<QD_HTML_TPL
<img src="{$sLogo}" />
<h1><a href="{$sHome}" title="{$sNom}">{$sNom}</a></h1>

QD_HTML_TPL;
	}
	// '
	return $hTete;
}

/*--------------------------------------------------*/

/** 
 * Fonction pour retourner le formulaire Html de connexion et d'administration
 * @name	f_admin_tpl()
 * @version	0101
 * --
 * @param	string	$sPage	Valeur indiquant la page actuellement affichée
 * @param	number	$nJob	Valeur indiquant le type d'action en cours
 * @param	boolean	$bPub	Valeur indiquant le contenu est à publier
 * @return	string	$hAdmin	Code Html du formulaire à afficher
 */
function f_admin_tpl($sPage, $nJob, $bPub) {
	global $bAdmin, $bRedac;
	$sSelf = QDSELF;
	$sVar = QDPGE;
	$sJob = QDJOB;
	$sPub = QDPUB;
	if (empty($sPage)) { $sPage = QDDFPG; }
	$hCnf = '';
	if ($bAdmin) { $hCnf = f_admin_cnf_tpl($sPage, $bPub); }
	if ($bAdmin || $bRedac) {
		if ($nJob) {
			$hAdmin = <<<QD_HTML_TPL
<p>
<a href="{$sSelf}?{$sVar}={$sPage}&{$sJob}=0&fin=1" title="Deconnexion (D)"><input type="button" value="&nbsp;D&eacute;connexion&nbsp;" accesskey="D" class="btn" /></a>
{$hCnf}
&nbsp;&nbsp;<a href="{$sSelf}?{$sVar}=&{$sJob}=2&{$sPub}={$bPub}" title="Nouvelle Page (N)"><input type="button" value="&nbsp;Nouvelle Page&nbsp;" accesskey="N" class="btn" /></a>
&nbsp;&nbsp;<a href="{$sSelf}?{$sVar}={$sPage}&{$sJob}=0&{$sPub}={$bPub}" title="Annuler (U)"><input type="button" value="&nbsp;Annuler&nbsp;" accesskey="U" class="btn" /></a>
</p>

QD_HTML_TPL;
		} else {
			$hAdmin = <<<QD_HTML_TPL
<p>
<a href="{$sSelf}?{$sVar}={$sPage}&{$sJob}=0&fin=1" title="Deconnexion (D)"><input type="button" value="&nbsp;D&eacute;connexion&nbsp;" accesskey="D" class="btn" /></a>
{$hCnf}
&nbsp;&nbsp;<a href="{$sSelf}?{$sVar}=&{$sJob}=2&{$sPub}={$bPub}" title="Nouvelle Page (N)"><input type="button" value="&nbsp;Nouvelle Page&nbsp;" accesskey="N" class="btn" /></a>
&nbsp;&nbsp;<a href="{$sSelf}?{$sVar}={$sPage}&{$sJob}=1&{$sPub}={$bPub}" title="Éditer Page (E)"><input type="button" value="&nbsp;&Eacute;diter Page&nbsp;" accesskey="E" class="btn" /></a>
</p>

QD_HTML_TPL;
		}
	} else {
		$hAdmin = <<<QD_HTML_TPL
<p>
<form action="{$sSelf}" method="post" id="adminform">
<input type="hidden" name="qdpge" value="{$sPage}" />
<input type="hidden" name="qdjob" value="{$nJob}" />
<input type="hidden" name="qdpub" value="{$bPub}" />
<input type="password" name="qdmdp" id="qdmdp" value="" size="12" title="Mot de Passe" class="txt" />
&nbsp;&nbsp;<input type="submit" name="qdadm" value="&nbsp;Connexion&nbsp;" accesskey="C" title="Connexion  (C)" class="btn" />
</form>
</p>

QD_HTML_TPL;
	}
	// '
	return $hAdmin;
}

/** 
 * Fonction pour retourner le code Html du bouton de configuration
 * @name	f_admin_cnf_tpl()
 * @version	0101
 * --
 * @param	string	$sPage	Valeur indiquant la page actuellement affichée
 * @return	string	$hAdmin	Code Html du bouton à afficher
 */
function f_admin_cnf_tpl($sPage, $bPub) {
	$sJob = QDJOB;
	$sSelf = QDSELF;
	$sVar = QDPGE;
	$sPub = QDPUB;
	$hAdmin = <<<QD_HTML_TPL
&nbsp;&nbsp;<a href="{$sSelf}?{$sVar}={$sPage}&{$sJob}=-1&{$sPub}={$bPub}" title="Configuration (G)"><input type="button" value="&nbsp;Configuration&nbsp;" accesskey="G" class="btn" /></a>

QD_HTML_TPL;
	// '
	return $hAdmin;
}

/*--------------------------------------------------*/

/** 
 * Fonction pour retourner la signature de la page (lien qkDocs et/ou autres éléments)
 * @name	f_sign_tpl()
 * @version	0101
 * --
 * @param	string	$sPage	Valeur indiquant la page actuellement affichée
 * @return	string	$hSign	Code Html de la signature de la page
 */
function f_sign_tpl($sPage) {
	if (empty($sPage)) { $sPage = QDDFPG; }
	$sName = QDNAME;
	$sVers = QDVERS;
	$sCopy = QDCOPY;
	$sLink = QDLINK;
	$hCmpt = '';
	if (function_exists('f_sc')) { $hCmpt = '&nbsp;'.LF.'<a href="_qd/_sc.php?sc=xyz" title="Vues~Visites" target="_blank">'.f_sc($sPage).'</a>'; }
	$hSign = <<<QD_HTML_TPL
<p>
<a href="{$sLink}" title="{$sName} {$sVers} - {$sCopy}" target="_blank">{$sName}</a>{$hCmpt}
</p>

QD_HTML_TPL;
	// '
	return $hSign;
}

/*--------------------------------------------------*/

/** 
 * Fonction pour retourner le code Html du menu pages
 * @name	f_menu_tpl()
 * @version	0101
 * --
 * @param	string	$sMenu	Code Html de la liste des pages à afficher
 * @return	string	$hMenu	Code Html du menu à afficher
 */
function f_menu_tpl($sMenu, $sNom='Pages', $sId='menupages') {
	$hMenu = <<<QD_HTML_TPL
<p class="titre"><a href="javascript:f_showhide('{$sId}');">{$sNom}</a></p>
<div id="{$sId}">
{$sMenu}
</div>
<p class="sep"></p>

QD_HTML_TPL;
	// '
	return $hMenu;
}

/** 
 * Fonction pour retourner le code Html du menu pages
 * @name	f_menu_tpl()
 * @version	0101
 * --
 * @param	string	$sMenu	Code Html de la liste des pages à afficher
 * @return	string	$hMenu	Code Html du menu à afficher
 */
function f_rech_tpl($sMenu, $sPage, $nJob, $bPub) {
	global $bAdmin, $bRedac, $sRecherche;
	$sSelf = QDSELF;
	$sVar = QDPGE;
	$sJob = QDJOB;
	$sPub = QDPUB;
	$sUrl = '';
	if ($bAdmin || $bRedac) { $sUrl = '&'.$sJob.'='.$nJob.'&'.$sPub.'='.$bPub; }
	$sRech = '';
	if (!empty($sRecherche)) { $sRech = htmlspecialchars(stripslashes($sRecherche), ENT_QUOTES, "UTF-8"); }
	$hMenu = <<<QD_HTML_TPL
<p class="titre"><a href="javascript:f_showhide('menurech');">Recherche</a></p>
<div id="menurech">
<form action="{$sSelf}" method="post">
<input type="hidden" name="qdpge" value="{$sPage}" />
<input type="hidden" name="qdjob" value="{$nJob}" />
<input type="hidden" name="qdpub" value="{$bPub}" />
<input type="text" id="qdrch" name="qdrch" value="{$sRech}" class="txt" />
<a href="{$sSelf}?{$sVar}={$sPage}{$sUrl}" title="Annuler recherche"><input type="button" value="X" class="btn" /></a>
<input type="submit" value="&radic;" accesskey="F" title="Chercher (F)" class="btn" />
</form>
{$sMenu}
</div>
<p class="sep"></p>

QD_HTML_TPL;
	// '
	return $hMenu;
}

/*--------------------------------------------------*/

/** 
 * Fonction pour retourner le code Html du menu pages
 * @name	f_cont_tpl()
 * @version	0101
 * --
 * @param	string	$sCont	Code Html du contenu à afficher
 * @param	string	$sNom	Nom de la page à afficher
 * @return	string	$hCont	Code Html de la page à afficher
 */
function f_cont_tpl($sCont, $sNom) {
	$hCont = <<<QD_HTML_TPL
<p class="titre">{$sNom}</p>
<div id="article">
{$sCont}
</div><!-- #article -->

QD_HTML_TPL;
	// '
	return $hCont;
}

/** 
 * Fonction pour retourner le formulaire d'édition d'un article
 * @name	f_article_tpl()
 * @version	0101
 * --
 * @param	string	$sPage	L'identifiant de la page à éditer
 * @param	string	$sNom	Le nom du fichier
 * @param	number	$nJob	Le type d'action en cours
 * @param	string	$sCont	Le contenu à éditer
 * @return	string	$hForm	Code Html du formulaire d'édition 
 */
function f_article_tpl($sPage, $sNom, $nJob, $bPub, $sCont) {
	global $bAdmin, $bRedac;
	$sSelf = QDSELF;
	$sVar = QDPGE;
	$sJob = QDJOB;
	$sPub = QDPUB;
	$sHaut = QDHAUT;
	$sLong = QDLNG;
	$sInfo = '';
	if ($bAdmin) { $sInfo = '<br />Effacez le nom et enregistrez le formulaire pour supprimer la page (sauf la page d\'accueil).'; }
	$aChk = array('', ' checked="checked"');
	$sPub = $aChk[$bPub];
	$sArch = f_article_archive_tpl($sPage);
	$sCoul = '';
	if (QDCOUL) { $sCoul = f_article_coul_tpl(); }
	$sSmy = '';
	if (QDSMYL) { $sSmy = f_article_smyl_tpl(); }
	$hForm = <<<QD_HTML_TPL
<p class="titre">Rédiger</p>
<div id="article">
<form action="{$sSelf}" method="post">
<input type="hidden" name="qdpge" value="{$sPage}" />
<input type="hidden" name="qdjob" value="{$nJob}" />
<input type="hidden" name="qdbup" value="{$bPub}" />
<p><label for="qdnom">Nom de la page :</label><br />
<input id="qdnom" name="qdnom" value="{$sNom}" class="ttr" />
<input type="checkbox" id="qdpub" name="qdpub" value="1"{$sPub} accesskey="k" title="Cocher pour publier la page (k)" /><label for="qdpub">&nbsp;Publier cette page</label><br />
<small><em>Numérotez le nom des pages pour gérer leur ordre d'apparition dans le menu de navigation.{$sInfo}</em></small></p>
<p><label for="qdtxt">Contenu de la page : </label><br />
<textarea id="qdtxt" name="qdtxt" cols="80" rows="40" style="height: {$sHaut}px;">{$sCont}</textarea></p>
<p id="infos">&nbsp;</p>
<p class="tags">
<input type="button" value="!" title="Gras (!)" accesskey="!" onclick="f_mktag(this, '!!', '!!', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="/" title="Italique (/)" accesskey="/" onclick="f_mktag(this, '\/\/', '\/\/', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="+" title="Grand (+)" accesskey="+" onclick="f_mktag(this, '++', '++', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="&minus;" title="Petit (-)" accesskey="-" onclick="f_mktag(this, '--', '--', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="_" title="Souligné (_)" accesskey="_" onclick="f_mktag(this, '__', '__', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="~" title="Barré (?)" accesskey="?" onclick="f_mktag(this, '~~', '~~', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="," title="Indice (,)" accesskey="," onclick="f_mktag(this, ',,', ',,', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="^" title="Exposant (*)" accesskey="*" onclick="f_mktag(this, '^^', '^^', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value=';' title="Citation (;)" accesskey=";" onclick="f_mktag(this, ';;', ';;', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value=":" title="Code (:)" accesskey=":" onclick="f_mktag(this, '::', '::', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="\\" title="Retour (£)" accesskey="£" onclick="f_mktag(this, '\\\\', '\\\\', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
</p>
<p class="tags">
<input type="button" value="I" title="Image (i)" accesskey="i" onclick="f_mktag(this, '{{', '}}', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="L" title="Lien (l)" accesskey="l" onclick="f_mktag(this, '[[', ']]', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="A" title="Ancre (a)" accesskey="a" onclick="f_mktag(this, '[[', '#]]', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="E" title="E-mail (e)" accesskey="e" onclick="f_mktag(this, '[[', '@]]', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="#" title="Note bas de page (#)" accesskey="#" onclick="f_mktag(this, '[(#)(', ')]', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="1" title="Titre 1 (1)" accesskey="1" onclick="f_mktag(this, '==', '==', 'qdtxt', 0, 1); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="2" title="Titre 2 (2)" accesskey="2" onclick="f_mktag(this, '===', '===', 'qdtxt', 0, 1); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="3" title="Titre 3 (3)" accesskey="3" onclick="f_mktag(this, '====', '====', 'qdtxt', 0, 1); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value=';' title="Citation (c)" accesskey="c" onclick="f_mktag(this, ';;;', ';;;', 'qdtxt', 0, 1); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value=":" title="Code (d)" accesskey="d" onclick="f_mktag(this, ':::', ':::', 'qdtxt', 0, 1); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="&minus;" title="Ligne (=)" accesskey="=" onclick="f_mktag(this, '----', '', 'qdtxt', 0, 1); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
</p>
{$sCoul}
{$sSmy}
<hr />
{$sArch}
<p style="text-align:center;"><input type="submit" name="qdsve" value="&nbsp;&nbsp;Enregistrer&nbsp;&nbsp;" accesskey="s" title="Enregistrer (s)" class="btn" /></p>
</form>
</div><!-- #article -->

QD_HTML_TPL;
	// '
	return $hForm;
}

function f_article_smyl_tpl() {
	$hSmyl = <<<QD_HTML_TPL
<p class="tags">
<input type="button" value="l" title=":-|" onclick="f_mktag(this, ' :-| ', '', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value=")" title=":-)" onclick="f_mktag(this, ' :-) ', '', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="}" title=":-}" onclick="f_mktag(this, ' :-} ', '', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="]" title=":-]" onclick="f_mktag(this, ' :-] ', '', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="p" title=":-p" onclick="f_mktag(this, ' :-p ', '', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value=";" title=";-)" onclick="f_mktag(this, ' ;-) ', '', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="o" title=":-o" onclick="f_mktag(this, ' :-o ', '', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="8" title="8-/" onclick="f_mktag(this, ' 8-/ ', '', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="/" title=":-/" onclick="f_mktag(this, ' :-/ ', '', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="(" title=":-(" onclick="f_mktag(this, ' :-( ', '', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="-" title=")-(" onclick="f_mktag(this, ' )-( ', '', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
</p>

QD_HTML_TPL;
	// '
	return $hSmyl;

}

function f_article_coul_tpl() {
	$hCoul = <<<QD_HTML_TPL
<p class="tags">
<input type="button" value="r" title="Rouge (r)" accesskey="r" onclick="f_mktag(this, '%%r|', '%%', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="v" title="Vert (v)" accesskey="v" onclick="f_mktag(this, '%%v|', '%%', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="b" title="Bleu (b)" accesskey="b" onclick="f_mktag(this, '%%b|', '%%', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="j" title="Jaune (j)" accesskey="j" onclick="f_mktag(this, '%%j|', '%%', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="n" title="Bleu Nuit (n)" accesskey="n" onclick="f_mktag(this, '%%n|', '%%', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="o" title="Orange (o)" accesskey="o" onclick="f_mktag(this, '%%o|', '%%', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="p" title="Pourpre (p)" accesskey="p" onclick="f_mktag(this, '%%p|', '%%', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="m" title="Marron (m)" accesskey="m" onclick="f_mktag(this, '%%m|', '%%', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value='t' title="Turquoise (t)" accesskey="t" onclick="f_mktag(this, '%%t|', '%%', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="g" title="Gris (g)" accesskey="g" onclick="f_mktag(this, '%%g|', '%%', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
<input type="button" value="c" title="Blanc (w)" accesskey="w" onclick="f_mktag(this, '%%c|', '%%', 'qdtxt', 0, 0); return false;" onmouseover="f_infos(this, 'infos'); return false;" />
</p>

QD_HTML_TPL;
	// '
	return $hCoul;

}


/** 
 * Fonction pour conserver la dernière version précédente de l'article
 * @name	f_article_archive_tpl()
 * @version	0101
 * --
 * @param	string	$sPage	Valeur indiquant la page actuellement affichée
 * @return	string	$hArch	Code Html de l'archive à récupérer
 */
function f_article_archive_tpl($sPage) {
	$hArch = '';
	$sArchFile = QDARCH.$sPage.QDTXT;
	if (is_file($sArchFile)) {
		$sCont = stripslashes(implode('', file($sArchFile)));
		$hArch = <<<QD_HTML_TPL
<p class="btns"><input type="button" value="Rétablir le contenu de la version précédente de cette page" onclick="f_archive('qdarch', 'qdtxt'); return false;" /></p>
<textarea id="qdarch" style="display: none;">
{$sCont}
</textarea>

QD_HTML_TPL;
	}
	// '
	return $hArch;
}

/*--------------------------------------------------*/

/** 
 * Fonction pour retourner le formulaire Html de configuration utilisateur
 * @name	f_config_tpl()
 * @version	0101
 * --
 * @param	string	$sPage	Valeur indiquant la page actuellement affichée
 * @param	number	$nJob	Valeur indiquant le type d'action en cours
 * @return	string	$hConfig	Code Html du formulaire à afficher 
 */
function f_config_tpl($sPage, $nJob, $bPub) {
	$sSelf = QDSELF;
	$sVar = QDPGE;
	$sJob = QDJOB;
	$sPub = QDPUB;
	if (empty($sPage)) { $sPage = QDDFPG; }
	$sSite = QDSITE;
	$sLogo = QDLOGO;
	$sAdmn = QDADMN;
	$sRdac = QDRDAC;
	$sDftNom = QDDFNM;
	$sUpmx = QDUPMX;
	$sHaut = QDHAUT;
	$nSmyl = QDSMYL;
	$nCoul = QDCOUL;
	$nTrgt = QDTRGT;
	$nMsqn = QDMSQN;
	$sLong = QDLNG;
	$aChk = array('', ' checked="checked"');
	$sSmyl = $aChk[$nSmyl];
	$sCoul = $aChk[$nCoul];
	$sTrgt = $aChk[$nTrgt];
	$sMsqn = $aChk[$nMsqn];
	$hConfig = <<<QD_HTML_TPL
<p class="titre">Configuration</p>
<div id="article">
<form action="{$sSelf}" method="post">
<input type="hidden" name="qdpge" value="{$sPage}" />
<input type="hidden" name="qdjob" value="{$nJob}" />
<input type="hidden" name="qdpub" value="{$bPub}" />
<p><label for="qdsite">Nom du site :</label><br />
<input type="text" id="qdsite" name="qdsite" value="{$sSite}" class="nom" /><br />
<small><em>Ce nom sera affiché sur le bandeau de tête du site.</em></small></p>
<p><label for="qdlogo">Logo du site :</label><br />
<input type="text" id="qdlogo" name="qdlogo" value="{$sLogo}" class="nom" /><br />
<small><em>Adresse Url du logo qui sera affiché sur le bandeau de tête du site. Hauteur maximum de 64px.</em></small></p>
<p><label for="qddfnm">Nom par défaut de la page d'accueil :</label><br />
<input type="text" id="qddfnm" name="qddfnm" value="{$sDftNom}" class="nom" /><br />
<small><em>La page d'accueil par défaut apparaît toujours en premier dans le menu de navigation et ne peut être supprimée.</em></small></p>
<hr />
<p><label for="qdadmn">Mot de passe administrateurs :</label><br />
<input type="text" id="qdadmn" name="qdadmn" value="{$sAdmn}" class="txt" /><br />
<small><em>Entre 4 et 10 lettres ou chiffres. Ne pas utiliser des caractères accentués ou spéciaux.</em></small></p>
<p><label for="qdrdac">Mot de passe rédacteurs :</label><br />
<input type="text" id="qdrdac" name="qdrdac" value="{$sRdac}" class="txt" /><br />
<small><em>Entre 4 et 10 lettres ou chiffres. Ne pas utiliser des caractères accentués ou spéciaux.</em></small></p>
<hr />
<p><label for="qdupmx">Poids maximum des documents Pdf et Zip à télédéposer (upload) :</label><br />
<input type="text" id="qdupmx" name="qdupmx" value="{$sUpmx}" class="nbr" />&nbsp;Mo<br />
<small><em>Veuillez indiquer un nombre entier correspondant au poids maximum autorisé (en méga-octets).</em></small></p>
<p><label for="qdhaut">Hauteur du champ de saisie :</label><br />
<input type="text" id="qdhaut" name="qdhaut" value="{$sHaut}" class="nbr" />&nbsp;px<br />
<small><em>Veuillez indiquer un nombre entier correspondant à la hauteur désirée (en pixels).</em></small></p>
<hr />
<p><input type="checkbox" id="qdcoul" name="qdcoul" value="1"{$sCoul} />
<label for="qdcoul">&nbsp;Afficher les boutons des couleurs.</label><br />
<small><em>Cochez cette case pour afficher les boutons permettant de colorier les textes.</em></small></p>
<p><input type="checkbox" id="qdsmyl" name="qdsmyl" value="1"{$sSmyl} />
<label for="qdsmyl">&nbsp;Insérer les images des smileys.</label><br />
<small><em>Cochez cette case pour remplacer les smileys textes par leur correspondant en image<br />
et pour afficher les boutons permettant d\'insérer les smileys dans le texte.</em></small></p>
<p><input type="checkbox" id="qdtrgt" name="qdtrgt" value="1"{$sTrgt} />
<label for="qdtrgt">&nbsp;Ouvrir les liens externes dans des nouvelle fenêtres.</label><br />
<small><em>Cochez cette case pour ouvrir les liens externes présents dans les pages dans des nouvelles fenêtres.</em></small></p>
<p><input type="checkbox" id="qdmsqn" name="qdmsqn" value="1"{$sMsqn} />
<label for="qdmsqn">&nbsp;Masquer la numérotation des pages dans le menu de navigation et dans le titre affiché.</label><br />
<small><em>Pour pouvoir gérer l'ordre d'apparition des pages dans le menu de navigation, vous pouvez préfixer leur nom avec un numéro, par&nbsp;ex.&nbsp;: "1&nbsp;Une&nbsp;page", "2&nbsp;Autre&nbsp;page", etc. Cette option permet donc de masquer cette numérotation. <b>Attention</b>, le tri des pages se faisant de manière alphanumérique, la page numérotée "11" apparaîtra avant celle numérotée "2", pour rétablir un ordre numérique, il faut précéder les nombres inférieurs à 10 d'un zéro, par&nbsp;ex.&nbsp;: "01&nbsp;Une&nbsp;page", "02&nbsp;Autre&nbsp;page", etc.</em></small></p>
<hr />
<p class="btns"><input type="button" value="Rétablir les valeurs originales" onclick="f_cnfdft(); return true;" /></p>
<p style="text-align:center;"><input type="submit" name="qdcnf" value="&nbsp;&nbsp;Enregistrer&nbsp;&nbsp;" accesskey="s" title="Enregistrer (s)" class="btn" /></p>
</form>
</div><!-- #article -->

QD_HTML_TPL;
	// ' 
	return $hConfig;
}

/*--------------------------------------------------*/

/** 
 * Fonction pour retourner le menu des images disponibles (jpg et png)
 * @name	f_img_tpl()
 * @version	0101
 * --
 * @param	string	$sPage	L'identifiant de la page à éditer
 * @param	number	$nJob	Le type d'action en cours
 * @param	string	$sType	Le de fichiers à afficher
 * @param	string	$hLink	Le code Html de la liste des fichiers
 * @param	string	$hOpt	Le code Html du popup-menu des fichiers
 * @return	string	$hForm	Code Html du menu
 */
function f_img_tpl($sPage, $nJob, $bPub, $sType, $hLink, $hOpt) {
	global $bAdmin, $bRedac;
	$sSelf = QDSELF;
	$sVar = QDPGE;
	$sJob = QDJOB;
	$sPub = QDPUB;
	$hDel = '';
	if ($bAdmin) { $hDel = f_img_del_tpl($sPage, $nJob, $bPub, $hOpt); }
	$hForm = <<<QD_HTML_TPL
<p class="titre"><a href="javascript:f_showhide('newimg');" title="Formats supportés : .jpg, .png et .gif">Importer Image</a></p>
<div id="newimg" style="display: none;">
<form action="{$sSelf}" method="post" enctype="multipart/form-data">
<input type="hidden" name="qdpge" value="{$sPage}" />
<input type="hidden" name="qdjob" value="{$nJob}" />
<input type="hidden" name="qdpub" value="{$bPub}" />
<input type="hidden" name="qdtyp" value="{$sType}" />
<input type="file" name="qddoc" class="doc" /><br />
<input type="submit" name="qdupl" value=" Importer Image " class="btn" />
</form>
</div>
{$hDel}
<p class="titre"><a href="javascript:f_showhide('previsuimg');" title="Formats supportés : .jpg, .png et .gif">Prévisualiser Image</a></p>
<div id="previsuimg" style="display: none;">
<p><img id="imgprevisu" src="" alt="_" /></p>
</div>
<p class="titre"><a href="javascript:f_showhide('listimg');" title="Formats listés : .jpg, .png et .gif">Liste Images</p>
<div id="listimg" style="display: block;">
{$hLink}
</div>
<p class="sep"></p>

QD_HTML_TPL;
	// '
	return $hForm;
}

/** 
 * Fonction pour retourner le menu de suppression d'images (jpg et png)
 * @name	f_img_del_tpl()
 * @version	0101
 * --
 * @param	string	$sPage	L'identifiant de la page à éditer
 * @param	number	$nJob	Le type d'action en cours
 * @param	string	$hOpt	Le code Html du popup-menu des fichiers
 * @return	string	$hForm	Code Html du menu
 */
function f_img_del_tpl($sPage, $nJob, $bPub, $hOpt) {
	$sSelf = QDSELF;
	$hForm = <<<QD_HTML_TPL
<p class="titre"><a href="javascript:f_showhide('delimg');" title="Formats supportés : .jpg, .png et .gif">Supprimer Image</a></p>
<div id="delimg" style="display: none;">
<form action="{$sSelf}" method="post">
<input type="hidden" name="qdpge" value="{$sPage}" />
<input type="hidden" name="qdjob" value="{$nJob}" />
<input type="hidden" name="qdpub" value="{$bPub}" />
<select id="qddocdel" name="qddocdel">
{$hOpt}
</select><br />
<input type="submit" name="qddel" value=" Supprimer Image " class="btn" />
</form>
</div>

QD_HTML_TPL;
	// '
	return $hForm;
}

/*--------------------------------------------------*/

/** 
 * Fonction pour retourner le menu des documents disponibles (pdf et zip)
 * @name	f_doc_tpl()
 * @version	0101
 * --
 * @param	string	$sPage	L'identifiant de la page à éditer
 * @param	number	$nJob	Le type d'action en cours
 * @param	string	$sType	Le de fichiers à afficher
 * @param	string	$hLink	Le code Html de la liste des fichiers
 * @param	string	$hOpt	Le code Html du popup-menu des fichiers
 * @return	string	$hForm	Code Html du menu
 */
function f_doc_tpl($sPage, $nJob, $bPub, $sType, $hLink, $hOpt) {
	global $bAdmin, $bRedac;
	$sSelf = QDSELF;
	$sVar = QDPGE;
	$sJob = QDJOB;
	$sPub = QDPUB;
	$hDel = '';
	if ($bAdmin) { $hDel = f_doc_del_tpl($sPage, $nJob, $bPub, $hOpt); }
	$hForm = <<<QD_HTML_TPL
<p class="titre"><a href="javascript:f_showhide('newdoc');" title="Formats supportés : .pdf et .zip">Importer Document</a></p>
<div id="newdoc" style="display: none;">
<form action="{$sSelf}" method="post" enctype="multipart/form-data">
<input type="hidden" name="qdpge" value="{$sPage}" />
<input type="hidden" name="qdjob" value="{$nJob}" />
<input type="hidden" name="qdpub" value="{$bPub}" />
<input type="hidden" name="qdtyp" value="{$sType}" />
<input type="file" name="qddoc" class="doc" /><br />
<input type="submit" name="qdupl" value=" Importer Document " class="btn" />
</form>
</div>
{$hDel}
<p class="titre"><a href="javascript:f_showhide('listdoc');" title="Formats listés : .pdf et .zip">Liste Documents</p>
<div id="listdoc" style="display: block;">
{$hLink}
</div>
<p class="sep"></p>

QD_HTML_TPL;
	// '
	return $hForm;
}

/** 
 * Fonction pour retourner le menu de suppression de documents (pdf et zip)
 * @name	f_doc_del_tpl()
 * @version	0101
 * --
 * @param	string	$sPage	L'identifiant de la page à éditer
 * @param	number	$nJob	Le type d'action en cours
 * @param	string	$hOpt	Le code Html du popup-menu des fichiers
 * @return	string	$hForm	Code Html du menu
 */
function f_doc_del_tpl($sPage, $nJob, $bPub, $hOpt) {
	$sSelf = QDSELF;
	$hForm = <<<QD_HTML_TPL
<p class="titre"><a href="javascript:f_showhide('deldoc');" title="Formats supportés : .pdf et .zip">Supprimer Document</a></p>
<div id="deldoc" style="display: none;">
<form action="{$sSelf}" method="post">
<input type="hidden" name="qdpge" value="{$sPage}" />
<input type="hidden" name="qdjob" value="{$nJob}" />
<input type="hidden" name="qdpub" value="{$bPub}" />
<select id="qddocdel" name="qddocdel">
{$hOpt}
</select><br />
<input type="submit" name="qddel" value=" Supprimer Document " class="btn" />
</form>
</div>

QD_HTML_TPL;
	// '
	return $hForm;
}

/*--------------------------------------------------*/

/** 
 * Fonction pour retourner le contenu d'un fichier "index.html" de redirection
 * @name	f_index_tpl()
 * @version	0101
 * --
  * @return	string	$hHtml	Code Html du fichier index
 */
function f_index_tpl() {
	return <<<QD_HTML_TPL
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<head>
<title>index</title>
<meta http-equiv="refresh" content="0; url=../">
</head>
<body>
<div style="text-align: center;"><a href="../"><strong>index</strong></a></div>
</body>
</html>
QD_HTML_TPL;
}

/*------------------------------------------------------------------------------------------------------------------------------------------------------*\
	Librairie de fonctions - Tools
\*------------------------------------------------------------------------------------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------------------------------*/
// Fonctions de travail avec des fichiers et des dossiers

/**
 * Fonction qui returne une liste de tous les fichiers existants dans un repertoire
 * @name	f_read_dir()
 * @version	0101
 * --
 * @param	string	$pDir	Chemin d'accès (path) du dossier à lister
 * @return	array	$aRes	Liste de noms des éléments présents dans le dossier analysé
 */
function f_read_dir($pDir='') {
	if (empty($pDir)) { $pDir = QDPAGES; } // dirname(__FILE__).'/'; }
	if ($rDir = opendir($pDir)) {
		$aRes = array();
		while (($sFile = readdir($rDir)) !== false) {
			if ($sFile[0] == '.') { continue; } else { $aRes[] = $sFile; }
		}
		closedir($rDir);
		return $aRes;
	}
}

/** 
 * Fonction pour lire et retourner le contenu d'un fichier
 * @name	f_read_s()
 * @version	0101
 * --
 * @param	string	$sPath	Chemin d'accès vers le fichier à lire
 * @return	string	$sRes	Le texte récupéré
 */
function f_read_s($sPath) {
	$sRes = '';
	if (@file_exists($sPath)) { 
		$sRes = implode('', file($sPath)); 
	}
	return $sRes;
}

/** 
 * Fonction pour écrire du contenu dans un fichier
 * @name	f_write_b()
 * @version	0101
 * --
 * @param	string	$sPath	Chemin d'accès vers le fichier
 * @param	string	$sData	Les données à sauvegarder
 * @param	string	$sMode	Le mode d'ouverture et d'écriture : wb = création et effacement ; ab = création et ajout.
 * @return	boolean	$bRes	Verification du bon deroulement de l'écriture
 */
function f_write_b($sPath, $sData, $sMode='wb') {
	// Creation ou ouverture du fichier en ecriture seule, son contenu est efface si mode "wb"
	// utiliser le mode "ab" pour ajouter des donnees a un fichier deja existant
	$nLong = strlen((string)$sData);
	$rOpen = @fopen($sPath, $sMode);
	$nRes = @fwrite($rOpen, $sData); // Ecriture des nouvelles valeurs suivant leur longueur
	@fclose($rOpen); // Fermeture du fichier
	$bRes = 0 + (bool)($nRes == $nLong); // Comparaison de la longeur des donnees ecrites avec celles fournies
	return $bRes;
}

/*--------------------------------------------------*/
// Fonctions de travail avec des listes

/** 
 * Fonction pour filtrer les items d'une liste selon deux paramètres fournis
 * @name	f_filter_list()
 * @version	0101
 * --
 * @param	array	$aListe	La liste de valeurs texte à filtrer
 * @param	string	$sOui	Masque RegEx des valeurs texte qui doivent être présentes pour conserver l'élément
 * @param	string	$sNon	Masque RegEx des valeurs texte qui doivent être absentes pour conserver l'élément
 * @return	array	$aRes	Liste des éléments filtrés
 */
function f_filter_list($aListe, $sOui='', $sNon='') {
	$aRes = array();
	if (empty($sOui)) { $sOui = '`('.ET.')`'; }
	if (empty($sNon)) { $sNon = '`('.BS.')`'; }
	foreach ($aListe as $sVal) {
		if (preg_match($sOui, $sVal) && !preg_match($sNon, $sVal)) {
			$aRes[$sVal] = strtr($sVal, '_', ' ');
		}
	}
	return $aRes;
}

/** 
 * Fonction qui retourne le tableau fourni trie par ordre croissant ou décroissant
 * @name	f_sort_list_a()
 * @version	0101
 * --
 * @param	array	$aList	La liste à trier
 * @param	boolean	$bZa	Ordre de tri : defaut 0 (zero) = tri croissant ; 1 = tri décroisssant.
 * @param	number	$nTyp	Le type de tri : defaut 0 (zero) = tris normal sur la valeur 'sort()' ; 1 = tri associatif sur la valeur 'asort()' ; > 1 = tri associatif sur la clé 'ksort()'.
 * @return	array	$aList	La liste triée
 */
function f_sort_list_a($aList, $bZa=0, $nTyp=0) {
	if ($bZa) {
		if ($nTyp > 1) {
			krsort($aList);
		} else if ($nTyp) {
			arsort($aList);
		} else {
			rsort($aList);
		}
	} else {
		if ($nTyp > 1) {
			ksort($aList);
		} else if ($nTyp) {
			asort($aList);
		} else {
			sort($aList);
		}
	}
	return $aList;
}

/*--------------------------------------------------*/
// Fonctions de conversion et cryptage des adresses Url et e-mail

/** 
 * Fonction pour retourner le texte Html fourni converti en codes Ascii Html 
 * @name	f_crypt_html()
 * @version	0101
 * --
 * @param	string	$sTxt	Le texte a convertir
 * @param	boolean	$bBruit	Indique l'activation du brouillage du texte
 * @param	integer	$nPas	La pas pour le brouillage du code (commentairs Html)
 * @return	string	$hTxt	Le code Html converti
 */
function f_crypt_html($sTxt, $bBruit=0, $nPas=3) {
// Petite adaptation d'un code issu d'une contribution sur Spip'Contrib proposee par Jean Luc Girard et Coyote, merci a eux.
// Voir : <http://www.spip-contrib.net/Crypter-une-adresse-email>
        $hTxt = '';
        for ($i = 0; $i < strlen($sTxt); $i++) {
		$hTxt .= '&#'.ord($sTxt[$i]).';';
		if ($bBruit && ($i > 0) && (($i % $nPas) === 0)) { $hTxt .= '<!--'.mt_rand(1, $i).'-->'; }
        }
      return $hTxt;
}

/** 
 * Fonction pour retourner le texte fourni en codes hexadecimaux de type "%NN"
 * @name	f_crypt_hexa()
 * @version	0101
 * --
 * @param	string	$sTxt	Le texte a convertir
 * @return	string	$sHexa	Le texte converti
 */
function f_crypt_hexa($sTxt) {
// Les "NN" ce sont des nombres qui correspondent a un caractere de l'alphabet
// Antispam (Jerome Lipowicz)
// Source : DotClear/inc/classes/class.wiki2xhtml.basic.php -> __antiSpam
// Doc : http://pagesperso-orange.fr/coin.des.experts/reponses/faq9_29.html
	$sHexa = bin2hex($sTxt);
	$sHexa = chunk_split($sHexa, 2, '%');
	$sHexa = '%'.substr($sHexa, 0, strlen($sHexa) - 1);
	return $sHexa;
}

/*--------------------------------------------------*/
// Fonctions de conversion et nettoyage des textes

/** 
 * Fonction pour nettoyer les noms des fichiers avant de les créer
 * @name	f_clean_names()
 * @version	0101
 * --
 * @param	string	$sNom	Le nom de fichier ou dossier à nettoyer
 * @param	integer	$nLong	La longueur maximum du texte
 * @return	array	$aRes	Le nom de la page et le nom original nettoyés 
 */
function f_clean_names($sNom, $bDoc=0) {
	$aRes = array();
	
	if (!empty($sNom)) {
		$nLong = 0 + QDLNG;
		$aAccents = array(' ', 'À', 'Ã', 'Ä', 'Å', 'Â', 'Á', 'Æ', 'É', 'Ê', 'Ë', 'È', 'Í', 'Î', 'Ï', 'Ì', 'Ó', 'Ô', 'Ò', 'Ö', 'Õ', 'Œ', 'Ü', 'Ú', 'Û', 'Ù', 'Ÿ', 'Ç', 'Ñ', 'á', 'à', 'â', 'ä', 'ã', 'å', 'æ', 'é', 'è', 'ê', 'ë', 'í', 'ì', 'î', 'ï', 'ó', 'ò', 'ô', 'ö', 'õ', 'œ', 'ú', 'ù', 'û', 'ü', 'ÿ', 'ç', 'ñ');
		$aNormal = array('_', 'A', 'A', 'A', 'A', 'A', 'A', 'AE', 'E', 'E', 'E', 'E', 'I', 'I', 'I', 'I', 'O', 'O', 'O', 'O', 'O', 'OE', 'U', 'U', 'U', 'U', 'Y', 'C', 'N', 'a', 'a', 'a', 'a', 'a', 'a', 'ae', 'e', 'e', 'e', 'e', 'i', 'i', 'i', 'i', 'o', 'o', 'o', 'o', 'o', 'oe', 'u', 'u', 'u', 'u', 'y', 'c', 'n');
		$sDoc = stripslashes($sNom);
		$sDoc = str_replace($aAccents, $aNormal, $sDoc);
		$sDoc = preg_replace('`([^-._a-z0-9]+)`i', '', $sDoc);
		$sDoc = str_replace(array('....', '...', '..'), '.', $sDoc);
		$sDoc = str_replace(array('----', '---', '--'), '-', $sDoc);
		$sDoc = str_replace(array('____', '___', '__'), '_', $sDoc);
		
		if ($bDoc && (strlen($sDoc) > ($nLong + 4))) {
			$sNme = f_nom_sans_ext($sDoc);
			$sExt = f_ext_sans_nom($sDoc);
			$sDoc = substr($sNme, 0, $nLong).$sExt; 
	
		} else if (!$bDoc && (strlen($sDoc) > $nLong)) {
			$sDoc = substr($sDoc, 0, $nLong);
		}
		
		$aRes['doc'] = $sDoc;
		$aRes['nom'] = htmlspecialchars(stripslashes($sNom), ENT_QUOTES, "UTF-8");
	}
	
	return $aRes;
}

/** 
 * Fonction pour supprimer la derniere extension ".ext" et retourner le reste du nom du fichier
 * @name	f_nom_sans_ext()
 * @version	0101
 * --
 * @param	string	$sNom	Le nom de fichier
 * @return	string	$sNom	Le nom sans l'extension
 */
function f_nom_sans_ext($sNom) {
	if (strpos($sNom, '.') !== false) { return substr($sNom, 0, strrpos($sNom, '.')); } else { return $sNom; };
}

/** 
 * Fonction pour retourner la derniere extension ".ext" du nom du fichier
 * @name	f_ext_sans_nom()
 * @version	0101
 * --
 * @param	string	$sNom	Le nom de fichier
 * @return	string	$sNom	Le nom sans l'extension
 */
function f_ext_sans_nom($sNom) {
	if (strpos($sNom, '.') !== false) { return substr($sNom, strrpos($sNom, '.'), strlen($sNom)); } else { return $sNom; };
}

/**
 * Fonction pour retourner le code Html fourni avec des espaces insecables
 * avant ou apres les signes de ponctuation qui en ont besoin à l'intérieur des balises.
 * @name	f_clean_typo_html()
 * @version	0101
 * --
 * @param	string	$sText	Le texte a nettoyer
 * @return	string	$sRes	Le texte nettoyé
 */
function f_clean_typo_html($sText) {
	if (empty($sText)) { return ''; }
	$sChrEspace = 32;
	$sChrInsec = 126; // 126 = ~ (tilde = alt + n) // Espace insécable manuelle
	$sInsecable = '&nbsp;';
	$aChrAvant = array(33, 36, 37, 38, 43, 45, 58, 59, 61, 63, 128, 133, 137, 155, 169, 174, 177, 187, 216, 248);
	$aChrApres = array(35, 43, 45, 61, 139, 149, 161, 169, 171, 174, 177, 191);
	
	// $aCarAvant = array(33=>'!', 36=>'$', 37=>'%', 38=>'&', 43=>'+', 45=>'-', 58=>':', 59=>';', 61=>'=', 63=>'?', 128=>'€', 133=>'…', 137=>'‰', 155=>'›', 169=>'©', 174=>'®', 177=>'±', 187=>'»', 216=>'Ø', 248=>'ø');
	// $aCarApres = array(35=>'#', 43=>'+', 45=>'-', 61=>'=', 139=>'‹', 149=>'•', 161=>'¡', 169=>'©', 171=>'«', 174=>'®', 177=>'±', 191=>'¿');
	
	// Espace insécable manuelle (tilde = ~ = 126 = alt + n)
	$sRes = str_replace(chr($sChrInsec), $sInsecable, $sText);
	
	// On isole les textes à l'intérieur des balises Html
	$sMsq = '`\>([^<\n]+)\<`';
	preg_match_all($sMsq, $sRes, $aText);
	$aRes = $aText[1];
	
	// Les espaces insécables avant les signes de ponctuation ou les unités de mesure
	foreach ($aChrAvant as $cle => $val) {
		$aRes = str_replace(chr($sChrEspace).chr($val), $sInsecable.chr($val), $aRes);
	}
	// Les espaces insécables après les signes de ponctuation ou les unités de mesure
	foreach ($aChrApres as $cle => $val) {
		$aRes = str_replace(chr($val).chr($sChrEspace), chr($val).$sInsecable, $aRes);
	}
	// Reconstruction du texte final
	$sRes = str_replace($aText[1], $aRes, $sRes);
	
	return $sRes;
}

/*----------------------------------------------------------------------------------------------------*/

?>
